# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.algorithm import Algorithm


class AbstractMapper(Algorithm):
    r"""
    AbstractMapper - abstract class specifies interface to map data
    
    Superclass: Algorithm
    
    AbstractMapper is an abstract class to specify interface between
    data and graphics primitives or software rendering techniques.
    Subclasses of AbstractMapper can be used for rendering 2D data,
    geometry, or volumetric data.
    
    @sa
    AbstractMapper3D Mapper PolyDataMapper VolumeMapper
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkAbstractMapper, obj, update, **traits)
    
    def _get_clipping_planes(self):
        return wrap_vtk(self._vtk_obj.GetClippingPlanes())
    def _set_clipping_planes(self, arg):
        old_val = self._get_clipping_planes()
        self._wrap_call(self._vtk_obj.SetClippingPlanes,
                        deref_vtk(arg))
        self.trait_property_changed('clipping_planes', old_val, arg)
    clipping_planes = traits.Property(_get_clipping_planes, _set_clipping_planes, desc=\
        r"""
        
        """
    )

    def get_abstract_scalars(self, *args):
        """
        get_abstract_scalars(input:DataSet, scalarMode:int,
            arrayAccessMode:int, arrayId:int, arrayName:str, cellFlag:int)
             -> AbstractArray
        C++: static AbstractArray *get_abstract_scalars(
            DataSet *input, int scalarMode, int arrayAccessMode,
            int arrayId, const char *arrayName, int &cellFlag)
        Internal helper function for getting the active scalars as an
        abstract array. The scalar mode indicates where the scalars come
        from.  The cellFlag is a return value that is set when the
        scalars actually are cell scalars.  (0 for point scalars, 1 for
        cell scalars, 2 for field scalars) The arrayaccess_mode is used to
        indicate how to retrieve the scalars from field data, per id or
        per name (if the scalarMode indicates that).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetAbstractScalars, *my_args)
        return wrap_vtk(ret)

    def get_ghost_array(self, *args):
        """
        get_ghost_array(input:DataSet, scalarMode:int, ghostsToSkip:int)
            -> UnsignedCharArray
        C++: static UnsignedCharArray *get_ghost_array(DataSet *input,
             int scalarMode, unsigned char &ghostsToSkip)
        Returns the ghost array associated with the corresponding scalar
        mode, if present. If no ghost array is available, this method
        returns `nullptr`. `ghoststo_skip` is an output, and is set to the
        bit mask associated with the ghost array in the `vtkfield_data` in
        which the ghost array lives. This bit mask can be ignored if
        `nullptr` is returned.
        
        @sa
        FieldData DataSetAttributes CellData PointData
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetGhostArray, *my_args)
        return wrap_vtk(ret)

    def _get_number_of_clipping_planes(self):
        return self._vtk_obj.GetNumberOfClippingPlanes()
    number_of_clipping_planes = traits.Property(_get_number_of_clipping_planes, desc=\
        r"""
        Get the number of clipping planes.
        """
    )

    def get_scalars(self, *args):
        """
        get_scalars(input:DataSet, scalarMode:int, arrayAccessMode:int,
            arrayId:int, arrayName:str, cellFlag:int) -> DataArray
        C++: static DataArray *get_scalars(DataSet *input,
            int scalarMode, int arrayAccessMode, int arrayId,
            const char *arrayName, int &cellFlag)
        Internal helper function for getting the active scalars. The
        scalar mode indicates where the scalars come from.  The cellFlag
        is a return value that is set when the scalars actually are cell
        scalars. (0 for point scalars, 1 for cell scalars, 2 for field
        scalars) The arrayaccess_mode is used to indicate how to retrieve
        the scalars from field data, per id or per name (if the
        scalarMode indicates that).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetScalars, *my_args)
        return wrap_vtk(ret)

    def _get_time_to_draw(self):
        return self._vtk_obj.GetTimeToDraw()
    time_to_draw = traits.Property(_get_time_to_draw, desc=\
        r"""
        Get the time required to draw the geometry last time it was
        rendered
        """
    )

    def add_clipping_plane(self, *args):
        """
        add_clipping_plane(self, plane:Plane) -> None
        C++: void add_clipping_plane(Plane *plane)
        Specify clipping planes to be applied when the data is mapped (at
        most 6 clipping planes can be specified).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.AddClippingPlane, *my_args)
        return ret

    def release_graphics_resources(self, *args):
        """
        release_graphics_resources(self, __a:Window) -> None
        C++: virtual void release_graphics_resources(Window *)
        Release any graphics resources that are being consumed by this
        mapper. The parameter window could be used to determine which
        graphic resources to release.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ReleaseGraphicsResources, *my_args)
        return ret

    def remove_all_clipping_planes(self):
        """
        remove_all_clipping_planes(self) -> None
        C++: void remove_all_clipping_planes()"""
        ret = self._vtk_obj.RemoveAllClippingPlanes()
        return ret
        

    def remove_clipping_plane(self, *args):
        """
        remove_clipping_plane(self, plane:Plane) -> None
        C++: void remove_clipping_plane(Plane *plane)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.RemoveClippingPlane, *my_args)
        return ret

    def shallow_copy(self, *args):
        """
        shallow_copy(self, m:AbstractMapper) -> None
        C++: virtual void shallow_copy(AbstractMapper *m)
        Make a shallow copy of this mapper.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ShallowCopy, *my_args)
        return ret

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(AbstractMapper, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit AbstractMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'object_name']),
            title='Edit AbstractMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit AbstractMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

