# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class AMRDataInternals(Object):
    r"""
    AMRDataInternals - container of UniformGrid for an AMR data set
    
    Superclass: Object
    
    AMRDataInternals stores a list of non-empty blocks of an AMR data
    set
    
    @sa
    OverlappingAMR, AMRBox
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkAMRDataInternals, obj, update, **traits)
    
    def get_data_set(self, *args):
        """
        get_data_set(self, compositeIndex:int) -> UniformGrid
        C++: UniformGrid *get_data_set(unsigned int compositeIndex)"""
        ret = self._wrap_call(self._vtk_obj.GetDataSet, *args)
        return wrap_vtk(ret)

    def _get_number_of_blocks(self):
        return self._vtk_obj.GetNumberOfBlocks()
    number_of_blocks = traits.Property(_get_number_of_blocks, desc=\
        r"""
        
        """
    )

    def composite_shallow_copy(self, *args):
        """
        composite_shallow_copy(self, src:Object) -> None
        C++: void composite_shallow_copy(Object *src)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.CompositeShallowCopy, *my_args)
        return ret

    def deep_copy(self, *args):
        """
        deep_copy(self, src:Object) -> None
        C++: void deep_copy(Object *src)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.DeepCopy, *my_args)
        return ret

    def empty(self):
        """
        empty(self) -> bool
        C++: bool empty()"""
        ret = self._vtk_obj.Empty()
        return ret
        

    def initialize(self):
        """
        initialize(self) -> None
        C++: void initialize()"""
        ret = self._vtk_obj.Initialize()
        return ret
        

    def insert(self, *args):
        """
        insert(self, index:int, grid:UniformGrid) -> None
        C++: void insert(unsigned int index, UniformGrid *grid)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.Insert, *my_args)
        return ret

    def shallow_copy(self, *args):
        """
        shallow_copy(self, src:Object) -> None
        C++: void shallow_copy(Object *src)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ShallowCopy, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(AMRDataInternals, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit AMRDataInternals properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit AMRDataInternals properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit AMRDataInternals properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

