# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_algorithm import PolyDataAlgorithm


class BoundaryMeshQuality(PolyDataAlgorithm):
    r"""
    BoundaryMeshQuality - Computes metrics on the boundary faces of a
    mesh.
    
    Superclass: PolyDataAlgorithm
    
    BoundaryMeshQuality computes metrics on the boundary faces of a
    volumetric mesh. The metrics that can be computed on the boundary
    faces of the mesh and are:
    - Distance from cell center to face center
    - Distance from cell center to face's plane
    - Angle of face's plane normal and cell center to face center vector
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkBoundaryMeshQuality, obj, update, **traits)
    
    angle_face_normal_and_cell_center_to_face_center_vector = tvtk_base.true_bool_trait(desc=\
        r"""
        Specify whether to compute the angle between the face normal and
        cell center to face center vector. The angle is in degrees.
        """
    )

    def _angle_face_normal_and_cell_center_to_face_center_vector_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAngleFaceNormalAndCellCenterToFaceCenterVector,
                        self.angle_face_normal_and_cell_center_to_face_center_vector_)

    distance_from_cell_center_to_face_center = tvtk_base.true_bool_trait(desc=\
        r"""
        Specify whether to compute the distance from the cell center ot
        the face center.
        """
    )

    def _distance_from_cell_center_to_face_center_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDistanceFromCellCenterToFaceCenter,
                        self.distance_from_cell_center_to_face_center_)

    distance_from_cell_center_to_face_plane = tvtk_base.true_bool_trait(desc=\
        r"""
        Specify whether to compute the distance from the cell center to
        the face's plane.
        """
    )

    def _distance_from_cell_center_to_face_plane_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDistanceFromCellCenterToFacePlane,
                        self.distance_from_cell_center_to_face_plane_)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('angle_face_normal_and_cell_center_to_face_center_vector',
    'GetAngleFaceNormalAndCellCenterToFaceCenterVector'),
    ('distance_from_cell_center_to_face_center',
    'GetDistanceFromCellCenterToFaceCenter'),
    ('distance_from_cell_center_to_face_plane',
    'GetDistanceFromCellCenterToFacePlane'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute',
    'angle_face_normal_and_cell_center_to_face_center_vector', 'debug',
    'distance_from_cell_center_to_face_center',
    'distance_from_cell_center_to_face_plane', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(BoundaryMeshQuality, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit BoundaryMeshQuality properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['angle_face_normal_and_cell_center_to_face_center_vector',
            'distance_from_cell_center_to_face_center',
            'distance_from_cell_center_to_face_plane'], [], ['abort_output',
            'object_name']),
            title='Edit BoundaryMeshQuality properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit BoundaryMeshQuality properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

