# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.implicit_function import ImplicitFunction


class Box(ImplicitFunction):
    r"""
    Box - implicit function for a bounding box
    
    Superclass: ImplicitFunction
    
    Box computes the implicit function and/or gradient for a
    axis-aligned bounding box. (The superclasses transform can be used to
    modify this orientation.) Each side of the box is orthogonal to all
    other sides meeting along shared edges and all faces are orthogonal
    to the x-y-z coordinate axes.  (If you wish to orient this box
    differently, recall that the superclass ImplicitFunction supports
    a transformation matrix.) Box is a concrete implementation of
    ImplicitFunction.
    
    @sa
    CubeSource ImplicitFunction BoundingBox
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkBox, obj, update, **traits)
    
    bounds = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(1e+299, -1e+299, 1e+299, -1e+299, 1e+299, -1e+299), cols=3, desc=\
        r"""
        
        """
    )

    def _bounds_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBounds,
                        self.bounds)

    def get_x_max(self, *args):
        """
        get_x_max(self, p:[float, float, float]) -> None
        C++: void get_x_max(double p[3])
        get_x_max(self, x:float, y:float, z:float) -> None
        C++: void get_x_max(double &x, double &y, double &z)"""
        ret = self._wrap_call(self._vtk_obj.GetXMax, *args)
        return ret

    def set_x_max(self, *args):
        """
        set_x_max(self, p:[float, float, float]) -> None
        C++: void set_x_max(double p[3])
        set_x_max(self, x:float, y:float, z:float) -> None
        C++: void set_x_max(double x, double y, double z)"""
        ret = self._wrap_call(self._vtk_obj.SetXMax, *args)
        return ret

    def get_x_min(self, *args):
        """
        get_x_min(self, p:[float, float, float]) -> None
        C++: void get_x_min(double p[3])
        get_x_min(self, x:float, y:float, z:float) -> None
        C++: void get_x_min(double &x, double &y, double &z)"""
        ret = self._wrap_call(self._vtk_obj.GetXMin, *args)
        return ret

    def set_x_min(self, *args):
        """
        set_x_min(self, p:[float, float, float]) -> None
        C++: void set_x_min(double p[3])
        set_x_min(self, x:float, y:float, z:float) -> None
        C++: void set_x_min(double x, double y, double z)
        Set / get the bounding box using various methods.
        """
        ret = self._wrap_call(self._vtk_obj.SetXMin, *args)
        return ret

    def add_bounds(self, *args):
        """
        add_bounds(self, bounds:(float, float, float, float, float, float))
             -> None
        C++: void add_bounds(const double bounds[6])
        A special method that allows union set operation on bounding
        boxes. Start with a set_bounds(). Subsequent add_bounds() methods
        are union set operations on the original bounds. Retrieve the
        final bounds with a get_bounds() method.
        """
        ret = self._wrap_call(self._vtk_obj.AddBounds, *args)
        return ret

    def intersect_box(self, *args):
        """
        intersect_box(bounds:(float, float, float, float, float, float),
            origin:(float, float, float), dir:(float, float, float),
            coord:[float, float, float], t:float, tolerance:float=0.0)
            -> str
        C++: static char intersect_box(const double bounds[6],
            const double origin[3], const double dir[3], double coord[3],
            double &t, double tolerance=0.0)
        Bounding box intersection with line modified from Graphics Gems
        Vol I. The method returns a non-zero value if the bounding box is
        hit. Origin[3] starts the ray, dir[3] is the vector components of
        the ray in the x-y-z directions, coord[3] is the location of hit,
        and t is the parametric coordinate along line. (Notes: the
        intersection ray dir[3] is NOT normalized.  Valid intersections
        will only occur between 0<=t<=1.)
        """
        ret = self._wrap_call(self._vtk_obj.IntersectBox, *args)
        return ret

    def intersect_with_infinite_line(self, *args):
        """
        intersect_with_infinite_line(bounds:(float, float, float, float,
            float, float), p1:(float, float, float), p2:(float, float,
            float), t1:float, t2:float, x1:[float, float, float],
            x2:[float, float, float], plane1:int, plane2:int) -> bool
        C++: static bool intersect_with_infinite_line(const double bounds[6],
             const double p1[3], const double p2[3], double &t1,
            double &t2, double x1[3], double x2[3], int &plane1,
            int &plane2)
        Same method as Box::IntersectWithLine, except that t1 and t2
        can be outside of [0,1]. t1 is the distance of x1 to p1 in
        parametric coordinates, and t2 is the distance of x2 to p1 in
        parametric coordinates as well. In Box::IntersectWithInLine,
        it is assumed that [p1,p2] is a segment, here, it is assumed that
        it is a line with no ends. t1 <= t2, which means that x1 is
        always "before" x2 on the line parameterized by [p1,p2]. x1 and
        x2 can be set to nullptr without crash.
        """
        ret = self._wrap_call(self._vtk_obj.IntersectWithInfiniteLine, *args)
        return ret

    def intersect_with_line(self, *args):
        """
        intersect_with_line(bounds:(float, float, float, float, float,
            float), p1:(float, float, float), p2:(float, float, float),
            t1:float, t2:float, x1:[float, float, float], x2:[float,
            float, float], plane1:int, plane2:int) -> int
        C++: static int intersect_with_line(const double bounds[6],
            const double p1[3], const double p2[3], double &t1,
            double &t2, double x1[3], double x2[3], int &plane1,
            int &plane2)
        Intersect a line with the box.  Give the endpoints of the line in
        p1 and p2.  The parameteric distances from p1 to the entry and
        exit points are returned in t1 and t2, where t1 and t2 are
        clamped to the range [0,1].  The entry and exit planes are
        returned in plane1 and plane2 where integers (0, 1, 2, 3, 4, 5)
        stand for the (xmin, xmax, ymin, ymax, zmin, zmax) planes
        respectively, and a value of -1 means that no intersection
        occurred.  The actual intersection coordinates are stored in x1
        and x2, which can be set to nullptr of you do not need them to be
        returned.  The function return value will be zero if the line is
        wholly outside of the box.
        """
        ret = self._wrap_call(self._vtk_obj.IntersectWithLine, *args)
        return ret

    def intersect_with_plane(self, *args):
        """
        intersect_with_plane(bounds:[float, float, float, float, float,
            float], origin:[float, float, float], normal:[float, float,
            float]) -> int
        C++: static TypeBool intersect_with_plane(double bounds[6],
            double origin[3], double normal[3])
        intersect_with_plane(bounds:[float, float, float, float, float,
            float], origin:[float, float, float], normal:[float, float,
            float], xout:[float, float, float, float, float, float, float,
             float, float, float, float, float, float, float, float,
            float, float, float]) -> int
        C++: static TypeBool intersect_with_plane(double bounds[6],
            double origin[3], double normal[3], double xout[18])
        Plane intersection with the box. The plane is infinite in extent
        and defined by an origin and normal. The function indicates
        whether the plane intersects, not the particulars of intersection
        points and such. The function returns non-zero if the plane and
        box intersect; zero otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.IntersectWithPlane, *args)
        return ret

    def is_box_in_frustum(self, *args):
        """
        is_box_in_frustum(planes:[float, float, float, float, float, float,
            float, float, float, float, float, float, float, float, float,
             float, float, float, float, float, float, float, float,
            float], bounds:[float, float, float, float, float, float])
            -> int
        C++: static TypeBool is_box_in_frustum(double planes[24],
            double bounds[6])
        Is a box in a frustum. Returns true if the box is in the frustum
        even partially. The frustum is defined as 6 planes. This method
        is not exact may and return true for cases where there is no
        intersection. It should never return false when there is an
        intersection though.
        """
        ret = self._wrap_call(self._vtk_obj.IsBoxInFrustum, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('bounds', 'GetBounds'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'bounds', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Box, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Box properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['bounds', 'object_name']),
            title='Edit Box properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Box properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

