# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell_grid_algorithm import CellGridAlgorithm


class CellGridComputeSides(CellGridAlgorithm):
    r"""
    CellGridComputeSides - Generate sides of input data (cells and/or
    sides) based on a strategy.
    
    Superclass: CellGridAlgorithm
    
    This filter simply adds or replaces a 2-component array for each type
    of side, for each cell type which identifies the set sides which are
    "un-shared." Internally, it uses a CellGridSidesQuery to obtain
    sides, so the cells in your CellGrid must provide a responder for
    this query type.
    
    This filter can be set to indicate which output data is copied
    directly from the input and which data is a set of sides generated
    from its input. This is used by the cell-grid representation in
    para_view to identify how selections should be extracted: sides not
    marked as "original" will result in their entire cell (not just the
    side) being extracted.
    
    @sa CellGridSidesQuery
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellGridComputeSides, obj, update, **traits)
    
    omit_sides_for_renderable_inputs = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/get whether sides should be computed if the cells are
        themselves renderable (surfaces, edges, or vertices).
        
        If this is true, no sides will be computed for inputs that are
        renderable. If false, then sides will be computed. Note that
        omit_sides_for_renderable_inputs is distinct from
        preserve_renderable_inputs, which determines whether renderable
        cells should be copied to the output.
        
        The default is false.
        """
    )

    def _omit_sides_for_renderable_inputs_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOmitSidesForRenderableInputs,
                        self.omit_sides_for_renderable_inputs_)

    preserve_renderable_inputs = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/get whether the output should include cells which are
        themselves renderable (surfaces, edges, or vertices) or should
        only include sides of the input cells.
        
        If you are implementing a responder, you are expected to employ
        this query parameter.
        """
    )

    def _preserve_renderable_inputs_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPreserveRenderableInputs,
                        self.preserve_renderable_inputs_)

    output_dimension_control = traits.Int(32, enter_set=True, auto_set=False, desc=\
        r"""
        Set/get a bit-vector flag indicating which sides of which
        dimension to generate.
        
        \sa CellGridSidesQuery
        """
    )

    def _output_dimension_control_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOutputDimensionControl,
                        self.output_dimension_control)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def _get_side_attribute(self):
        return wrap_vtk(self._vtk_obj.GetSideAttribute())
    side_attribute = traits.Property(_get_side_attribute, desc=\
        r"""
        
        """
    )

    _updateable_traits_ = \
    (('omit_sides_for_renderable_inputs',
    'GetOmitSidesForRenderableInputs'), ('preserve_renderable_inputs',
    'GetPreserveRenderableInputs'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('output_dimension_control', 'GetOutputDimensionControl'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'omit_sides_for_renderable_inputs', 'preserve_renderable_inputs',
    'release_data_flag', 'abort_output', 'object_name',
    'output_dimension_control', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellGridComputeSides, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellGridComputeSides properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['omit_sides_for_renderable_inputs',
            'preserve_renderable_inputs'], [], ['abort_output', 'object_name',
            'output_dimension_control']),
            title='Edit CellGridComputeSides properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellGridComputeSides properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

