# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell_grid_query import CellGridQuery


class CellGridCopyQuery(CellGridQuery):
    r"""
    CellGridCopyQuery - Copy the cell metadata and attribute(s) of one
    cell-grid into another.
    
    Superclass: CellGridQuery
    
    Note that this query is run by CellGrid::ShallowCopy(),
    CellGrid::DeepCOpy(), and CellGrid::CopyStructure().
    
    In general, there are five types of information in cell grids that
    may be transferred from the source cell-grid to the target. Here are
    the types of information and the options which control how that
    information is copied. Exactly how these flags on the query are used
    is up to each responder.
    
    + **Cell metadata records.** These records are always copied.
      In the future, there may be an option to omit cells of specific
    types.
    
    + **Individual cells.** If subclasses of CellMetadata contain
      further information, you may use set_copy_cells() to control
      whether that is copied or whether the new CellMetadata
      instance is left uninitialized.
      When get_copy_cells() is enabled, the cell topology should be copied
      (though not necessarily the shape attribute's arrays);
      copy_cells overrides the copying of topological arrays even if
      copy_arrays is turned off.
      This way, if copy_cells is on, you should expect the source and
      target to report the same number of cells.
    
    + **Cell attributes.** You may request that only the shape attribute
      is copied from the source to the target with copy_only_shape_on()
      or control which attributes are copied by calling
      add_source_cell_attribute_id() with the ID of each source attribute
      you wish copied.
    
    + **Cell-attribute arrays.** For each cell-attribute that is copied,
      zero or more arrays may be associated the attribute. You can
      control how the arrays are copied like so:
    
    
      + set_copy_arrays() controls whether arrays should be created or not.
        How the arrays are copied depends on whether copy_array_values and
        deep_copy_arrays are enabled. Note that this setting should be
        ignored when copying cell topology (as opposed to attribute)
    arrays
        as copy_cells should control whether cells are present in the
    output.
        If cell-topology arrays are referenced by a cell attribute, be
    aware
        that disabling copy_arrays may still produce some entries for
    topology
        arrays.
      + set_copy_array_values() controls whether arrays should be (a)
    created
        but left empty or (b) created and populated with the
    source-array's
        values. This is useful for creating an empty copy that has all
        the necessary arrays prepared but no tuples so that further
        processing can insert new cells and attribute data.
      + set_deep_copy_arrays() controls whether to create deep copies of
        arrays or shallow copies, but only when get_copy_array_values()
        returns true.
    
    + **Schema and content version.** A cell-grid may advertise that its
      data adheres to a formal specification (which is indicated by a
      name and version number). If you wish to copy this information,
      ensure copy_schema_on() has been called.
      If get_copy_schema() is true and the source has a content version
      number, the target cell-grid will have its content version
      incremented past the source's content version.
      Incrementing the content version even when the grids are otherwise
      identical improves track-ability, since the version number informs
      which grid preceded the other.
    
    ## For Callers
    
    You **must** execute this query on the source cell-grid, not the
    target. Only the source is guaranteed to have cells of the proper
    types present; the query iterates over each cell-type, so they must
    be present.
    
    Executing this query will overwrite the target cell-grid with the
    source, erasing all of its cell metadata. In the future, this class
    may offer more control over which types of cells to copy from the
    source to the target.
    
    ## For Responders
    
    Responders to this query may call the helper methods provided to copy
    a cell-attribute's arrays and create/update a cell-attribute. These
    calls update maps from source to target arrays and attributes, which
    you can inspect by calling get_array_map() and get_attribute_map(),
    respectively. The latter is important since distinct attributes may
    have identical names (though this is not advised).
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellGridCopyQuery, obj, update, **traits)
    
    copy_array_values = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _copy_array_values_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCopyArrayValues,
                        self.copy_array_values_)

    copy_arrays = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _copy_arrays_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCopyArrays,
                        self.copy_arrays_)

    copy_cell_types = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _copy_cell_types_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCopyCellTypes,
                        self.copy_cell_types_)

    copy_cells = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _copy_cells_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCopyCells,
                        self.copy_cells_)

    copy_only_shape = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _copy_only_shape_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCopyOnlyShape,
                        self.copy_only_shape_)

    copy_schema = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _copy_schema_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCopySchema,
                        self.copy_schema_)

    deep_copy_arrays = tvtk_base.false_bool_trait(desc=\
        r"""
        
        """
    )

    def _deep_copy_arrays_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDeepCopyArrays,
                        self.deep_copy_arrays_)

    def _get_source(self):
        return wrap_vtk(self._vtk_obj.GetSource())
    def _set_source(self, arg):
        old_val = self._get_source()
        self._wrap_call(self._vtk_obj.SetSource,
                        deref_vtk(arg))
        self.trait_property_changed('source', old_val, arg)
    source = traits.Property(_get_source, _set_source, desc=\
        r"""
        
        """
    )

    def _get_target(self):
        return wrap_vtk(self._vtk_obj.GetTarget())
    def _set_target(self, arg):
        old_val = self._get_target()
        self._wrap_call(self._vtk_obj.SetTarget,
                        deref_vtk(arg))
        self.trait_property_changed('target', old_val, arg)
    target = traits.Property(_get_target, _set_target, desc=\
        r"""
        
        """
    )

    def get_cell_attribute_ids(self, *args):
        """
        get_cell_attribute_ids(self, ids:IdList) -> None
        C++: void get_cell_attribute_ids(IdList *ids)
        Populate ids with the attribute IDs scheduled to be copied when
        the query is run.
        """
        my_args = deref_array(args, [['vtkIdList']])
        ret = self._wrap_call(self._vtk_obj.GetCellAttributeIds, *my_args)
        return ret

    def add_all_source_cell_attribute_ids(self):
        """
        add_all_source_cell_attribute_ids(self) -> bool
        C++: virtual bool add_all_source_cell_attribute_ids()
        Add all of the source cell-grid's attributes to the list of IDs
        to be copied.
        
        Obviously, you must have called set_source() prior to calling this
        method.
        """
        ret = self._vtk_obj.AddAllSourceCellAttributeIds()
        return ret
        

    def add_source_cell_attribute_id(self, *args):
        """
        add_source_cell_attribute_id(self, attributeId:int) -> bool
        C++: virtual bool add_source_cell_attribute_id(int attributeId)
        Add attributeId to the list of cell-attributes to be copied from
        the source.
        """
        ret = self._wrap_call(self._vtk_obj.AddSourceCellAttributeId, *args)
        return ret

    def copy_attribute_arrays(self, *args):
        """
        copy_attribute_arrays(self, srcAtt:CellAttribute,
            cellType:StringToken) -> None
        C++: void copy_attribute_arrays(CellAttribute *srcAtt,
            StringToken cellType)
        Copy the arrays for a single attribute from the source to the
        target.
        
        This method **does not** check copy_only_shape and cell_attribute_ids
        to determine whether the attribute should be copied. Your
        responder must verify the attribute should be copied.
        
        This method **does** check the copy_arrays, copy_arrays, and
        copy_array_values flags to determine whether to reference source
        arrays or create (and potentially copy values) into new arrays.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.CopyAttributeArrays, *my_args)
        return ret

    def copy_or_update_attribute_record(self, *args):
        """
        copy_or_update_attribute_record(self, srcAtt:CellAttribute,
            cellType:StringToken) -> CellAttribute
        C++: CellAttribute *copy_or_update_attribute_record(
            CellAttribute *srcAtt, StringToken cellType)
        Copy a cell-attribute ( srcAtt) from the source into the target.
        
        This method uses the array_map to set the arrays for each cell
        type (if arrays are being copied and not being copied by
        reference).
        
        This calls CellAttribute::DeepCopy() on srcAtt and then copies
        any cached range data from the source to the target cell-grid.
        
        Your responder **must** call copy_attribute_arrays() for all the
        output cell types **before** calling this method if
        get_copy_arrays() returns true so that the array_map will be
        properly populated.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.CopyOrUpdateAttributeRecord, *my_args)
        return wrap_vtk(ret)

    def remove_source_cell_attribute_id(self, *args):
        """
        remove_source_cell_attribute_id(self, attributeId:int) -> bool
        C++: virtual bool remove_source_cell_attribute_id(int attributeId)
        Remove attributeId from the list of cell-attributes to be copied
        from the source.
        """
        ret = self._wrap_call(self._vtk_obj.RemoveSourceCellAttributeId, *args)
        return ret

    def reset_cell_attribute_ids(self):
        """
        reset_cell_attribute_ids(self) -> None
        C++: virtual void reset_cell_attribute_ids()
        Reset the query so that no cell-attributes will be copied from
        the source.
        """
        ret = self._vtk_obj.ResetCellAttributeIds()
        return ret
        

    _updateable_traits_ = \
    (('copy_array_values', 'GetCopyArrayValues'), ('copy_arrays',
    'GetCopyArrays'), ('copy_cell_types', 'GetCopyCellTypes'),
    ('copy_cells', 'GetCopyCells'), ('copy_only_shape',
    'GetCopyOnlyShape'), ('copy_schema', 'GetCopySchema'),
    ('deep_copy_arrays', 'GetDeepCopyArrays'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['copy_array_values', 'copy_arrays', 'copy_cell_types', 'copy_cells',
    'copy_only_shape', 'copy_schema', 'debug', 'deep_copy_arrays',
    'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellGridCopyQuery, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellGridCopyQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['copy_array_values', 'copy_arrays', 'copy_cell_types',
            'copy_cells', 'copy_only_shape', 'copy_schema', 'deep_copy_arrays'],
            [], ['object_name']),
            title='Edit CellGridCopyQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellGridCopyQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

