# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class CellGridQuery(Object):
    r"""
    CellGridQuery - Perform an operation on cells in a CellMetadata
    instance.
    
    Superclass: Object
    
    This is an empty base class that all query types must inherit.
    
    The `vtkcell_grid::Query()` method calls the query's `Initialize()`
    implementation; then loops over all its cell-types (calling the
    best-matching responder's `Query()` method for that cell-type); then
    calls `Finalize()`.
    
    The responders have an opportunity to modify the state of the query
    object, so these methods are a chance to prepare your query's state
    and then perform reduce-like computations after all the cells have
    been handled.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellGridQuery, obj, update, **traits)
    
    def _get_pass_(self):
        return self._vtk_obj.GetPass()
    pass_ = traits.Property(_get_pass_, desc=\
        r"""
        Return the current pass (the number of times each responder has
        been evaluated so far).
        """
    )

    def finalize(self):
        """
        finalize(self) -> bool
        C++: virtual bool finalize()
        Override this if your query-result state requires finalization.
        """
        ret = self._vtk_obj.Finalize()
        return ret
        

    def initialize(self):
        """
        initialize(self) -> bool
        C++: virtual bool initialize()
        Override this if your query-result state requires initialization.
        
        You may override this method to do additional work, but you must
        be careful to call the base method from your override.
        
        Returning false will abort processing of the query. No error
        message will be printed.
        """
        ret = self._vtk_obj.Initialize()
        return ret
        

    def is_another_pass_required(self):
        """
        is_another_pass_required(self) -> bool
        C++: virtual bool is_another_pass_required()
        Override this if your query allows responders to execute in
        multiple phases. This method may do work in addition to returning
        whether another pass is needed.
        """
        ret = self._vtk_obj.IsAnotherPassRequired()
        return ret
        

    def start_pass(self):
        """
        start_pass(self) -> None
        C++: virtual void start_pass()
        Mark the start of a pass through each cell type. This increments
        the Pass ivar which responders can access.
        
        You may override this method to do additional work, but you must
        be careful to call the base method from your override.
        """
        ret = self._vtk_obj.StartPass()
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellGridQuery, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellGridQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit CellGridQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellGridQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

