# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.abstract_cell_links import AbstractCellLinks


class CellLinks(AbstractCellLinks):
    r"""
    CellLinks - object represents upward pointers from points to list
    of cells using each point
    
    Superclass: AbstractCellLinks
    
    CellLinks is a supplemental object to CellArray and
    CellTypes, enabling access from points to the cells using the
    points. CellLinks is a list of cell ids, each such link
    representing a dynamic list of cell ids using the point. The
    information provided by this object can be used to determine
    neighbors and construct other local topological information.
    
    @warning
    CellLinks supports incremental (i.e., "editable") operations such
    as inserting a new cell, or deleting a point. Because of this, it is
    less memory efficient, and slower to construct and delete than static
    classes such as StaticCellLinks or StaticCellLinksTemplate.
    However these other classes are typically meant for one-time (static)
    construction.
    
    @sa
    CellArray CellTypes StaticCellLinks
    StaticCellLinksTemplate
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellLinks, obj, update, **traits)
    
    def get_cells(self, *args):
        """
        get_cells(self, ptId:int) -> Pointer
        C++: IdType *get_cells(IdType ptId)
        Return a list of cell ids using the point.
        """
        ret = self._wrap_call(self._vtk_obj.GetCells, *args)
        return ret

    def get_ncells(self, *args):
        """
        get_ncells(self, ptId:int) -> int
        C++: IdType get_ncells(IdType ptId)
        Get the number of cells using the point specified by ptId.
        """
        ret = self._wrap_call(self._vtk_obj.GetNcells, *args)
        return ret

    def add_cell_reference(self, *args):
        """
        add_cell_reference(self, cellId:int, ptId:int) -> None
        C++: void add_cell_reference(IdType cellId, IdType ptId)
        Add the reference to the cell (cellId) from the point (ptId).
        This adds a reference to the cellId from the cell list, but does
        not resize the list (extend memory with resize_cell_list(), if
        necessary).
        """
        ret = self._wrap_call(self._vtk_obj.AddCellReference, *args)
        return ret

    def allocate(self, *args):
        """
        allocate(self, numLinks:int, ext:int=1000) -> None
        C++: void allocate(IdType numLinks, IdType ext=1000)
        Allocate the specified number of links (i.e., number of points)
        that will be built.
        """
        ret = self._wrap_call(self._vtk_obj.Allocate, *args)
        return ret

    def delete_point(self, *args):
        """
        delete_point(self, ptId:int) -> None
        C++: void delete_point(IdType ptId)
        Delete point (and storage) by destroying links to using cells.
        """
        ret = self._wrap_call(self._vtk_obj.DeletePoint, *args)
        return ret

    def insert_next_cell_reference(self, *args):
        """
        insert_next_cell_reference(self, ptId:int, cellId:int) -> None
        C++: void insert_next_cell_reference(IdType ptId,
            IdType cellId)
        Insert a cell id into the list of cells (at the end) using the
        cell id provided. (Make sure to extend the link list (if
        necessary) using the method resize_cell_list().)
        """
        ret = self._wrap_call(self._vtk_obj.InsertNextCellReference, *args)
        return ret

    def insert_next_point(self, *args):
        """
        insert_next_point(self, numLinks:int) -> int
        C++: IdType insert_next_point(int numLinks)
        Insert a new point into the cell-links data structure. The size
        parameter is the initial size of the list.
        """
        ret = self._wrap_call(self._vtk_obj.InsertNextPoint, *args)
        return ret

    def remove_cell_reference(self, *args):
        """
        remove_cell_reference(self, cellId:int, ptId:int) -> None
        C++: void remove_cell_reference(IdType cellId, IdType ptId)
        Delete the reference to the cell (cellId) from the point (ptId).
        This removes the reference to the cellId from the cell list, but
        does not resize the list (recover memory with resize_cell_list(),
        if necessary).
        """
        ret = self._wrap_call(self._vtk_obj.RemoveCellReference, *args)
        return ret

    def resize_cell_list(self, *args):
        """
        resize_cell_list(self, ptId:int, size:int) -> None
        C++: void resize_cell_list(IdType ptId, int size)
        Change the length of a point's link list (i.e., list of cells
        using a point) by the size specified.
        """
        ret = self._wrap_call(self._vtk_obj.ResizeCellList, *args)
        return ret

    _updateable_traits_ = \
    (('sequential_processing', 'GetSequentialProcessing'), ('debug',
    'GetDebug'), ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'sequential_processing',
    'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellLinks, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellLinks properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['sequential_processing'], [], ['object_name']),
            title='Edit CellLinks properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellLinks properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

