# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.unstructured_grid_algorithm import UnstructuredGridAlgorithm


class CleanUnstructuredGrid(UnstructuredGridAlgorithm):
    r"""
    CleanUnstructuredGrid - merge duplicate points
    
    Superclass: UnstructuredGridAlgorithm
    
    CleanUnstructuredGrid is a filter that takes unstructured grid
    data as input and generates unstructured grid data as output.
    CleanUnstructuredGrid can merge duplicate points (with coincident
    coordinates) using the MergePoints object to merge points.
    
    @sa
    CleanPolyData
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCleanUnstructuredGrid, obj, update, **traits)
    
    remove_points_without_cells = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get whether to remove points that do not have any cells
        associated with it. Default is false
        """
    )

    def _remove_points_without_cells_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRemovePointsWithoutCells,
                        self.remove_points_without_cells_)

    tolerance_is_absolute = tvtk_base.false_bool_trait(desc=\
        r"""
        By default tolerance_is_absolute is false and Tolerance is a
        fraction of Bounding box diagonal, if true, absolute_tolerance is
        used when adding points to locator (merging)
        """
    )

    def _tolerance_is_absolute_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetToleranceIsAbsolute,
                        self.tolerance_is_absolute_)

    absolute_tolerance = traits.Trait(1.0, traits.Range(0.0, 1e+299, enter_set=True, auto_set=False), desc=\
        r"""
        Specify tolerance in absolute terms. Default is 1.0.
        """
    )

    def _absolute_tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAbsoluteTolerance,
                        self.absolute_tolerance)

    def _get_locator(self):
        return wrap_vtk(self._vtk_obj.GetLocator())
    def _set_locator(self, arg):
        old_val = self._get_locator()
        self._wrap_call(self._vtk_obj.SetLocator,
                        deref_vtk(arg))
        self.trait_property_changed('locator', old_val, arg)
    locator = traits.Property(_get_locator, _set_locator, desc=\
        r"""
        
        """
    )

    output_points_precision = traits.Int(2, enter_set=True, auto_set=False, desc=\
        r"""
        Set/get the desired precision for the output types. See the
        documentation for the Algorithm::DesiredOutputPrecision enum
        for an explanation of the available precision settings.
        """
    )

    def _output_points_precision_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOutputPointsPrecision,
                        self.output_points_precision)

    point_data_weighing_strategy = traits.Trait(0, traits.Range(0, 2, enter_set=True, auto_set=False), desc=\
        r"""
        
        """
    )

    def _point_data_weighing_strategy_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPointDataWeighingStrategy,
                        self.point_data_weighing_strategy)

    tolerance = traits.Trait(0.0, traits.Range(0.0, 1.0, enter_set=True, auto_set=False), desc=\
        r"""
        Specify tolerance in terms of fraction of bounding box length.
        Default is 0.0.
        """
    )

    def _tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTolerance,
                        self.tolerance)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)
        get_input(self) -> DataObject
        C++: DataObject *get_input()"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def create_default_locator(self, *args):
        """
        create_default_locator(self, input:DataSet=...) -> None
        C++: void create_default_locator(DataSet *input=nullptr)
        Create default locator. Used to create one when none is
        specified.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.CreateDefaultLocator, *my_args)
        return ret

    def release_locator(self):
        """
        release_locator(self) -> None
        C++: void release_locator()
        Release locator
        """
        ret = self._vtk_obj.ReleaseLocator()
        return ret
        

    _updateable_traits_ = \
    (('remove_points_without_cells', 'GetRemovePointsWithoutCells'),
    ('tolerance_is_absolute', 'GetToleranceIsAbsolute'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('absolute_tolerance',
    'GetAbsoluteTolerance'), ('output_points_precision',
    'GetOutputPointsPrecision'), ('point_data_weighing_strategy',
    'GetPointDataWeighingStrategy'), ('tolerance', 'GetTolerance'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'remove_points_without_cells',
    'tolerance_is_absolute', 'abort_output', 'absolute_tolerance',
    'object_name', 'output_points_precision',
    'point_data_weighing_strategy', 'progress_text', 'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CleanUnstructuredGrid, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CleanUnstructuredGrid properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['remove_points_without_cells', 'tolerance_is_absolute'], [],
            ['abort_output', 'absolute_tolerance', 'object_name',
            'output_points_precision', 'point_data_weighing_strategy',
            'tolerance']),
            title='Edit CleanUnstructuredGrid properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CleanUnstructuredGrid properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

