# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.data_array import DataArray


class CompositeUnsignedLongLongArray(DataArray):
    r"""
    CompositeUnsignedLongLongArray - composite implicit array of
    unsigned long long.
    
    Superclass: DataArray
    
    CompositeUnsignedLongLongArray is a composite implicit array of
    values of type unsigned long long. see CompositeArray,
    CompositeImplicitBackend
    
    This file is generated by ImplicitArrays.cmake
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCompositeUnsignedLongLongArray, obj, update, **traits)
    
    def get_typed_tuple(self, *args):
        """
        get_typed_tuple(self, i:int, tuple:[int, ...]) -> None
        C++: void get_typed_tuple(IdType i, unsigned long long *tuple)"""
        ret = self._wrap_call(self._vtk_obj.GetTypedTuple, *args)
        return ret

    def get_value(self, *args):
        """
        get_value(self, id:int) -> int
        C++: unsigned long long get_value(IdType id)"""
        ret = self._wrap_call(self._vtk_obj.GetValue, *args)
        return ret

    def _get_value_range(self):
        return self._vtk_obj.GetValueRange()
    value_range = traits.Property(_get_value_range, desc=\
        r"""
        
        """
    )

    def get_value_range(self, *args):
        """
        get_value_range(self, comp:int) -> (int, int)
        C++: unsigned long long *get_value_range(int comp)
        get_value_range(self) -> (int, int)
        C++: unsigned long long *get_value_range()"""
        ret = self._wrap_call(self._vtk_obj.GetValueRange, *args)
        return ret

    def construct_backend(self, *args):
        """
        construct_backend(self, arrays:DataArrayCollection) -> None
        C++: void construct_backend(DataArrayCollection *arrays)
        Set the underlying arrays to use.
        """
        my_args = deref_array(args, [['vtkDataArrayCollection']])
        ret = self._wrap_call(self._vtk_obj.ConstructBackend, *my_args)
        return ret

    def extended_new(self):
        """
        extended_new() -> CompositeUnsignedLongLongArray
        C++: static CompositeUnsignedLongLongArray *extended_new()"""
        ret = wrap_vtk(self._vtk_obj.ExtendedNew())
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('max_discrete_values',
    'GetMaxDiscreteValues'), ('name', 'GetName'), ('number_of_components',
    'GetNumberOfComponents'), ('number_of_tuples', 'GetNumberOfTuples'),
    ('number_of_values', 'GetNumberOfValues'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'max_discrete_values', 'name',
    'number_of_components', 'number_of_tuples', 'number_of_values',
    'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CompositeUnsignedLongLongArray, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CompositeUnsignedLongLongArray properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['max_discrete_values', 'name', 'number_of_components',
            'number_of_tuples', 'number_of_values', 'object_name']),
            title='Edit CompositeUnsignedLongLongArray properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CompositeUnsignedLongLongArray properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

