# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.implicit_function import ImplicitFunction


class Cone(ImplicitFunction):
    r"""
    Cone - implicit function for a cone
    
    Superclass: ImplicitFunction
    
    Cone computes the implicit function and function gradient for a
    cone. Cone is a concrete implementation of ImplicitFunction. By
    default, the cone vertex is located at the origin with axis of
    rotation coincident with x-axis. You can use the superclass'
    ImplicitFunction transformation matrix to reposition. You can
    alternatively use the accessors provided by this class, which will
    cause the transform to be recomputed. to reposition/orient the cone.
    The angle specifies the angle between the axis of rotation and the
    side of the cone.
    
    @warning
    The cone is infinite in extent (on both sides if is_double_cone is set
    to true). To truncate the cone use the ImplicitBoolean in
    combination with clipping planes.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCone, obj, update, **traits)
    
    is_double_cone = tvtk_base.true_bool_trait(desc=\
        r"""
        Set/Get whether this is a double cone (extends to infinity on
        both directions along axis) or a one sided one (extends towards
        the axis direction only). Cone is a double cone by default.
        """
    )

    def _is_double_cone_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetIsDoubleCone,
                        self.is_double_cone_)

    angle = traits.Trait(45.0, traits.Range(0.0, 89.0, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the cone angle (expressed in degrees). Defaults to 45
        degrees.
        """
    )

    def _angle_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAngle,
                        self.angle)

    axis = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(1.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Get/Set the vector defining the direction of the cone. If the
        axis is not specified as a unit vector, it will be normalized. If
        zero-length axis vector is used as input to this method, it will
        be ignored. Defaults to the X axis (1, 0, 0).
        """
    )

    def _axis_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAxis,
                        self.axis)

    origin = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Set/Get the cone origin. Defaults to (0, 0, 0).
        """
    )

    def _origin_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrigin,
                        self.origin)

    _updateable_traits_ = \
    (('is_double_cone', 'GetIsDoubleCone'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('angle',
    'GetAngle'), ('axis', 'GetAxis'), ('origin', 'GetOrigin'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'is_double_cone', 'angle',
    'axis', 'object_name', 'origin'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Cone, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Cone properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['is_double_cone'], [], ['angle', 'axis', 'object_name',
            'origin']),
            title='Edit Cone properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Cone properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

