# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.implicit_function import ImplicitFunction


class CoordinateFrame(ImplicitFunction):
    r"""
    CoordinateFrame - implicit function for a right-handed coordinate
    system
    
    Superclass: ImplicitFunction
    
    CoordinateFrame computes an implicit function and function
    gradient for a set of 3 orthogonal planes.
    
    The function evaluates to a combination of quartic spherical harmonic
    basis functions:$\sqrt(\frac{7}{12})*Y_{4,0} +
    \sqrt(\frac{5}{12})*Y_{4,4} $ that – when evaluated on a unit
    sphere centered at the coordinate frame's origin – form a 6-lobed
    function with a maximum along each of the 6 axes (3 positive, 3
    negative). This function is frequently used in frame-field design.
    
    See the paper "On Smooth Frame Field Design" by Nicolas Ray and
    Dmitry Sokolov (2016, hal-01245657,
    https://hal.inria.fr/hal-01245657/file/framefield.pdf ) for more
    information.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCoordinateFrame, obj, update, **traits)
    
    origin = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Specify the point through which all 3 planes pass.
        """
    )

    def _origin_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrigin,
                        self.origin)

    x_axis = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(1.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Specify a list of unit-length normal vectors for each plane.
        """
    )

    def _x_axis_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetXAxis,
                        self.x_axis)

    y_axis = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 1.0, 0.0), cols=3, desc=\
        r"""
        
        """
    )

    def _y_axis_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetYAxis,
                        self.y_axis)

    z_axis = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 1.0), cols=3, desc=\
        r"""
        
        """
    )

    def _z_axis_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetZAxis,
                        self.z_axis)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('origin', 'GetOrigin'), ('x_axis',
    'GetXAxis'), ('y_axis', 'GetYAxis'), ('z_axis', 'GetZAxis'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name', 'origin',
    'x_axis', 'y_axis', 'z_axis'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CoordinateFrame, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CoordinateFrame properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name', 'origin', 'x_axis', 'y_axis',
            'z_axis']),
            title='Edit CoordinateFrame properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CoordinateFrame properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

