# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.table_algorithm import TableAlgorithm


class EqualizerFilter(TableAlgorithm):
    r"""
    EqualizerFilter - implements an algorithm for digital signal
    processing
    
    Superclass: TableAlgorithm
    
    The EqualizerFilter implements an algorithm that selectively
    corrects the signal amplitude depending on the frequency
    characteristics.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkEqualizerFilter, obj, update, **traits)
    
    all_columns = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        Set / Get a flag to process all columns of the table. If set to
        true, all columns of the table will be used. The "set_array()"
        method will have no effect. Default value is: false
        """
    )

    def _all_columns_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAllColumns,
                        self.all_columns)

    array = traits.String('', enter_set=True, auto_set=False, desc=\
        r"""
        Set / Get the name of the column from which the data array is
        taken
        """
    )

    def _array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArray,
                        self.array)

    points = traits.String('', enter_set=True, auto_set=False, desc=\
        r"""
        Set / Get anchor points in the following format "P1x,P1y;P2x,P2y; ...
        PNx,PNy;" Default value is an empty string
        """
    )

    def _points_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPoints,
                        self.points)

    sampling_frequency = traits.Int(1000, enter_set=True, auto_set=False, desc=\
        r"""
        Set / Get the sampling frequency of the original signal in Hz
        Default value is: 1000
        """
    )

    def _sampling_frequency_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSamplingFrequency,
                        self.sampling_frequency)

    spectrum_gain = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Set / Get the spectrum gain in dB Default value is: 0
        """
    )

    def _spectrum_gain_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSpectrumGain,
                        self.spectrum_gain)

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('all_columns',
    'GetAllColumns'), ('array', 'GetArray'), ('points', 'GetPoints'),
    ('sampling_frequency', 'GetSamplingFrequency'), ('spectrum_gain',
    'GetSpectrumGain'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'all_columns', 'array',
    'object_name', 'points', 'progress_text', 'sampling_frequency',
    'spectrum_gain'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(EqualizerFilter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit EqualizerFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'all_columns', 'array', 'object_name',
            'points', 'sampling_frequency', 'spectrum_gain']),
            title='Edit EqualizerFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit EqualizerFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

