# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.data_object_algorithm import DataObjectAlgorithm


class ExtractSelection(DataObjectAlgorithm):
    r"""
    ExtractSelection - extract a subset from a DataSet.
    
    Superclass: DataObjectAlgorithm
    
    ExtractSelection extracts some subset of cells and points from its
    input data object. The data object is given on its first input port.
    The subset is described by the contents of the Selection on its
    second input port.  Depending on the contents of the Selection
    this will create various Selectors to identify the selected
    elements.
    
    This filter supports CompositeDataSet, DataSet,
    HyperTreeGrid and Table.
    
    1. If preserve topology is on, the output type is the same as the
       input.
    2. If preserve topology is on.
    1. If input is a subclass of DataObjectTree, the output is the
       same subclass.
    2. If input is UniformGridAMR, the output is
       PartitionedDataSetCollection.
    3. If input is DataSet, the output is UnstructuredGrid.
    4. If input is HyperTreeGrid, the output is HyperTreeGrid or
       UnstructuredGrid depending on the
       hyper_tree_grid_to_unstructured_grid flag.
    5. If input is Table, the output is Table.
    
    Other types of input are not processed and the corresponding output
    is a default constructed object of the input type.
    
    @sa
    Selection Selector SelectionNode
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkExtractSelection, obj, update, **traits)
    
    hyper_tree_grid_to_unstructured_grid = tvtk_base.false_bool_trait(desc=\
        r"""
        
        """
    )

    def _hyper_tree_grid_to_unstructured_grid_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetHyperTreeGridToUnstructuredGrid,
                        self.hyper_tree_grid_to_unstructured_grid_)

    preserve_topology = tvtk_base.false_bool_trait(desc=\
        r"""
        This flag tells the extraction filter not to extract a subset of
        the data, but instead to produce a Insidedness array and add
        it to the input dataset. Default value is false(0).
        """
    )

    def _preserve_topology_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPreserveTopology,
                        self.preserve_topology_)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def set_selection_connection(self, *args):
        """
        set_selection_connection(self, algOutput:AlgorithmOutput) -> None
        C++: void set_selection_connection(AlgorithmOutput *algOutput)
        Convenience method to specify the selection connection (2nd input
        port)
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetSelectionConnection, *my_args)
        return ret

    _updateable_traits_ = \
    (('hyper_tree_grid_to_unstructured_grid',
    'GetHyperTreeGridToUnstructuredGrid'), ('preserve_topology',
    'GetPreserveTopology'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'hyper_tree_grid_to_unstructured_grid', 'preserve_topology',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ExtractSelection, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ExtractSelection properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['hyper_tree_grid_to_unstructured_grid', 'preserve_topology'],
            [], ['abort_output', 'object_name']),
            title='Edit ExtractSelection properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ExtractSelection properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

