# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.pass_through import PassThrough


class ForceStaticMesh(PassThrough):
    r"""
    ForceStaticMesh - Takes in input as a cache the first time it is
    executed then use it as a static mesh
    
    Superclass: PassThrough
    
    The Force Static Mesh filter create a cache the first time it is used
    using its input. It will then only update point_data, cell_data and
    field_data from the input if their dimensions are valid. This filter
    will keep the initial given geometry as long as its input keeps the
    same number of points and cells (and force_cache_computation is false).
    This may lead to inconsistent attributes if the geometry has changed
    its connectivity.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkForceStaticMesh, obj, update, **traits)
    
    force_cache_computation = tvtk_base.false_bool_trait(desc=\
        r"""
        When set to true, this will force this filter to recompute its
        cache. Default is false.
        """
    )

    def _force_cache_computation_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetForceCacheComputation,
                        self.force_cache_computation_)

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    _updateable_traits_ = \
    (('force_cache_computation', 'GetForceCacheComputation'),
    ('allow_null_input', 'GetAllowNullInput'), ('deep_copy_input',
    'GetDeepCopyInput'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'allow_null_input', 'debug', 'deep_copy_input',
    'force_cache_computation', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ForceStaticMesh, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ForceStaticMesh properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['allow_null_input', 'deep_copy_input',
            'force_cache_computation'], [], ['abort_output', 'object_name']),
            title='Edit ForceStaticMesh properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ForceStaticMesh properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

