# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.pass_input_type_algorithm import PassInputTypeAlgorithm


class GenerateIds(PassInputTypeAlgorithm):
    r"""
    GenerateIds - generate scalars or field data from point and cell
    ids
    
    Superclass: PassInputTypeAlgorithm
    
    GenerateIds is a filter that generates scalars or field data using
    cell and point ids. That is, the point attribute data scalars or
    field data are generated from the point ids, and the cell attribute
    data scalars or field data are generated from the cell ids.
    
    Typically this filter is used with LabeledDataMapper (and possibly
    SelectVisiblePoints) to create labels for points and cells, or
    labels for the point or cell data scalar values.
    
    This filter supports DataSet and HyperTeeGrid instances as
    input. In the case of HyperTreeGrid, only cell ids are generated.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGenerateIds, obj, update, **traits)
    
    cell_ids = tvtk_base.true_bool_trait(desc=\
        r"""
        Enable/disable the generation of cell ids. Default is on.
        
        ote: Unused if the input is a HyperTreeGrid instance (we have
        only cell data on HTGs, always on).
        """
    )

    def _cell_ids_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCellIds,
                        self.cell_ids_)

    field_data = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get the flag which controls whether to generate scalar data
        or field data. If this flag is off, scalar data is generated.
        Otherwise, field data is generated. Default is off.
        """
    )

    def _field_data_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetFieldData,
                        self.field_data_)

    point_ids = tvtk_base.true_bool_trait(desc=\
        r"""
        Enable/disable the generation of point ids. Default is on.
        
        ote: Unused if the input is a HyperTreeGrid instance (we do
        not have point data on HTGs, always off).
        """
    )

    def _point_ids_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPointIds,
                        self.point_ids_)

    cell_ids_array_name = traits.String('vtkCellIds', enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the name of the Ids array for points, if generated. By
        default, it is set to "vtkcell_ids".
        """
    )

    def _cell_ids_array_name_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCellIdsArrayName,
                        self.cell_ids_array_name)

    point_ids_array_name = traits.String('vtkPointIds', enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the name of the Ids array for points, if generated. By
        default, it is set to "vtkpoint_ids".
        
        ote: Unused if the input is a HyperTreeGrid instance.
        """
    )

    def _point_ids_array_name_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPointIdsArrayName,
                        self.point_ids_array_name)

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    _updateable_traits_ = \
    (('cell_ids', 'GetCellIds'), ('field_data', 'GetFieldData'),
    ('point_ids', 'GetPointIds'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('cell_ids_array_name', 'GetCellIdsArrayName'),
    ('point_ids_array_name', 'GetPointIdsArrayName'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'cell_ids', 'debug', 'field_data',
    'global_warning_display', 'point_ids', 'release_data_flag',
    'abort_output', 'cell_ids_array_name', 'object_name',
    'point_ids_array_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(GenerateIds, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit GenerateIds properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['cell_ids', 'field_data', 'point_ids'], [], ['abort_output',
            'cell_ids_array_name', 'object_name', 'point_ids_array_name']),
            title='Edit GenerateIds properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit GenerateIds properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

