# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.data_set_algorithm import DataSetAlgorithm


class GenerateProcessIds(DataSetAlgorithm):
    r"""
    GenerateProcessIds - Sets process_ids attribute for point_data
    and/or cell_data.
    
    Superclass: DataSetAlgorithm
    
    GenerateProcessIds is meant to fill in the process_ids attribute
    array, to know which processor owns which cells and points. It can
    generate it for both point_data and cell_data. The process_ids array's
    name will be "point_process_ids" for point_data, and "cell_process_ids"
    for cell_data.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGenerateProcessIds, obj, update, **traits)
    
    generate_cell_data = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get whether to generate process ids for cell_data. Default is
        false.
        """
    )

    def _generate_cell_data_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGenerateCellData,
                        self.generate_cell_data_)

    generate_point_data = tvtk_base.true_bool_trait(desc=\
        r"""
        Set/Get whether to generate process ids for point_data. Default is
        true.
        """
    )

    def _generate_point_data_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGeneratePointData,
                        self.generate_point_data_)

    def _get_controller(self):
        return wrap_vtk(self._vtk_obj.GetController())
    def _set_controller(self, arg):
        old_val = self._get_controller()
        self._wrap_call(self._vtk_obj.SetController,
                        deref_vtk(arg))
        self.trait_property_changed('controller', old_val, arg)
    controller = traits.Property(_get_controller, _set_controller, desc=\
        r"""
        
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    _updateable_traits_ = \
    (('generate_cell_data', 'GetGenerateCellData'),
    ('generate_point_data', 'GetGeneratePointData'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'generate_cell_data',
    'generate_point_data', 'global_warning_display', 'release_data_flag',
    'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(GenerateProcessIds, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit GenerateProcessIds properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['generate_cell_data', 'generate_point_data'], [],
            ['abort_output', 'object_name']),
            title='Edit GenerateProcessIds properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit GenerateProcessIds properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

