# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.abstract_transform import AbstractTransform


class GeoTransform(AbstractTransform):
    r"""
    GeoTransform - Describe a geographic transform
    
    Superclass: AbstractTransform
    
    Describe a geographic transform either using PROJ strings or using
    GeoProjection classes.
    
    WARNING: Normal vectors have to be removed before a transform using
    this class otherwise the transform will be a no-operation. See
    GeoTransform::InternalTransformDerivative.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGeoTransform, obj, update, **traits)
    
    def _get_destination_projection(self):
        return wrap_vtk(self._vtk_obj.GetDestinationProjection())
    def _set_destination_projection(self, arg):
        old_val = self._get_destination_projection()
        self._wrap_call(self._vtk_obj.SetDestinationProjection,
                        deref_vtk(arg))
        self.trait_property_changed('destination_projection', old_val, arg)
    destination_projection = traits.Property(_get_destination_projection, _set_destination_projection, desc=\
        r"""
        
        """
    )

    def _get_source_projection(self):
        return wrap_vtk(self._vtk_obj.GetSourceProjection())
    def _set_source_projection(self, arg):
        old_val = self._get_source_projection()
        self._wrap_call(self._vtk_obj.SetSourceProjection,
                        deref_vtk(arg))
        self.trait_property_changed('source_projection', old_val, arg)
    source_projection = traits.Property(_get_source_projection, _set_source_projection, desc=\
        r"""
        
        """
    )

    transform_z_coordinate = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        If true, we transform (x, y, z) otherwise we transform (x, y) and
        leave z unchanged. Default is false. This is used when converting
        from/to cartesian (cart) coordinate, but it could be used for
        other transforms as well.
        
        WARNING: 3D transforms work only if the transform is specified
        using PROJ strings or using GeoProjection that are specified
        using PROJ strings.
        """
    )

    def _transform_z_coordinate_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTransformZCoordinate,
                        self.transform_z_coordinate)

    def compute_utm_zone(self, *args):
        """
        compute_utm_zone(lon:float, lat:float) -> int
        C++: static int compute_utm_zone(double lon, double lat)
        compute_utm_zone(lonlat:[float, ...]) -> int
        C++: static int compute_utm_zone(double *lonlat)
        Computes Universal Transverse Mercator (UTM) zone given the
        longitude and latitude of the point. It correctly computes the
        zones in the two exception areas. It returns an integer between 1
        and 60 for valid long lat, or 0 otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.ComputeUTMZone, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('transform_z_coordinate',
    'GetTransformZCoordinate'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name',
    'transform_z_coordinate'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(GeoTransform, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit GeoTransform properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name', 'transform_z_coordinate']),
            title='Edit GeoTransform properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit GeoTransform properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

