# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class GLSLModifierBase(Object):
    r"""
    GLSLModifierBase - Abstract class that helps you develop modifier
    for VTK GLSL shaders
    
    Superclass: Object
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGLSLModifierBase, obj, update, **traits)
    
    def GLSL_MODIFIERS(self):
        """
        glsl__modifiers() -> InformationObjectBaseKey
        C++: static InformationObjectBaseKey *glsl__modifiers()
        if this key exists on the shader_mods of DrawTexturedElements,
        that mod will be applied before rendering.
        """
        ret = wrap_vtk(self._vtk_obj.GLSL_MODIFIERS())
        return ret
        

    def is_up_to_date(self, *args):
        """
        is_up_to_date(self, renderer:OpenGLRenderer,
            mapper:AbstractMapper, actor:Actor) -> bool
        C++: virtual bool is_up_to_date(OpenGLRenderer *renderer,
            AbstractMapper *mapper, Actor *actor)
        Whether mod needs to be re-applied. Return true if your mod's
        replace_shader_values must be run again. Typically, you'd want to
        perform the shader substitutions again if properties fundamental
        to the shader construction have been modified.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.IsUpToDate, *my_args)
        return ret

    def replace_shader_values(self, *args):
        """
        replace_shader_values(self, renderer:OpenGLRenderer,
            vertexShader:str, tessControlShader:str, tessEvalShader:str,
            geometryShader:str, fragmentShader:str,
            mapper:AbstractMapper, actor:Actor) -> bool
        C++: virtual bool replace_shader_values(OpenGLRenderer *renderer,
             std::string &vertexShader, std::string &tessControlShader,
            std::string &tessEvalShader, std::string &geometryShader,
            std::string &fragmentShader, AbstractMapper *mapper,
            Actor *actor)
        Abstract interfaces to replace shader values and apply parameters
        as uniform values.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ReplaceShaderValues, *my_args)
        return ret

    def set_primitive_type(self, *args):
        """
        set_primitive_type(self, primType:int) -> None
        C++: void set_primitive_type(unsigned int primType)
        The renderer will set primitive type.
        """
        ret = self._wrap_call(self._vtk_obj.SetPrimitiveType, *args)
        return ret

    def set_shader_parameters(self, *args):
        """
        set_shader_parameters(self, renderer:OpenGLRenderer,
            program:ShaderProgram, mapper:AbstractMapper,
            actor:Actor, VAO:OpenGLVertexArrayObject=...) -> bool
        C++: virtual bool set_shader_parameters(OpenGLRenderer *renderer,
             ShaderProgram *program, AbstractMapper *mapper,
            Actor *actor, OpenGLVertexArrayObject *VAO=nullptr)"""
        my_args = deref_array(args, [('vtkOpenGLRenderer', 'vtkShaderProgram', 'vtkAbstractMapper', 'vtkActor', 'vtkOpenGLVertexArrayObject')])
        ret = self._wrap_call(self._vtk_obj.SetShaderParameters, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(GLSLModifierBase, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit GLSLModifierBase properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit GLSLModifierBase properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit GLSLModifierBase properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

