# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hyper_tree_grid_algorithm import HyperTreeGridAlgorithm


class HyperTreeGridContour(HyperTreeGridAlgorithm):
    r"""
    HyperTreeGridContour - Extract cells from a hyper tree grid where
    selected scalar value is within given range.
    
    Superclass: HyperTreeGridAlgorithm
    
    This filter extracts cells from a hyper tree grid that satisfy the
    following contour: a cell is considered to be within range if its
    value for the active scalar is within a specified range (inclusive).
    The output remains a hyper tree grid.
    
    @sa
    HyperTreeGrid HyperTreeGridAlgorithm ContourFilter
    
    @par Thanks: This class was written by Guenole Harel and
    Jacques-Bernard Lekien 2014 This class was revised by Philippe Pebay,
    2016 This class was modified by Jacques-Bernard Lekien, 2018 This
    work was supported by Commissariat a l'Energie Atomique CEA, DAM,
    DIF, F-91297 Arpajon, France.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHyperTreeGridContour, obj, update, **traits)
    
    use_implicit_arrays = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get wether or not the filter should use implicit arrays to
        store the output contour values (stored as point data of the
        output contour). Since these values are the same fo each
        isosurface, some memory can be saved by storing each value only
        once unsing an indexed array.
        
        @attention This option have no effect if there is more than 256
        contour values.
        """
    )

    def _use_implicit_arrays_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseImplicitArrays,
                        self.use_implicit_arrays_)

    def _get_locator(self):
        return wrap_vtk(self._vtk_obj.GetLocator())
    def _set_locator(self, arg):
        old_val = self._get_locator()
        self._wrap_call(self._vtk_obj.SetLocator,
                        deref_vtk(arg))
        self.trait_property_changed('locator', old_val, arg)
    locator = traits.Property(_get_locator, _set_locator, desc=\
        r"""
        
        """
    )

    number_of_contours = traits.Int(1, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _number_of_contours_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfContours,
                        self.number_of_contours)

    def get_value(self, *args):
        """
        get_value(self, __a:int) -> float
        C++: double get_value(int)"""
        ret = self._wrap_call(self._vtk_obj.GetValue, *args)
        return ret

    def set_value(self, *args):
        """
        set_value(self, __a:int, __b:float) -> None
        C++: void set_value(int, double)
        Methods (inlined) to set / get contour values.
        """
        ret = self._wrap_call(self._vtk_obj.SetValue, *args)
        return ret

    def _get_strategy3d_max_value(self):
        return self._vtk_obj.GetStrategy3DMaxValue()
    strategy3d_max_value = traits.Property(_get_strategy3d_max_value, desc=\
        r"""
        
        """
    )

    def _get_strategy3d_min_value(self):
        return self._vtk_obj.GetStrategy3DMinValue()
    strategy3d_min_value = traits.Property(_get_strategy3d_min_value, desc=\
        r"""
        
        """
    )

    def _get_values(self):
        return self._vtk_obj.GetValues()
    values = traits.Property(_get_values, desc=\
        r"""
        
        """
    )

    def get_values(self, *args):
        """
        get_values(self) -> Pointer
        C++: double *get_values()
        get_values(self, __a:[float, ...]) -> None
        C++: void get_values(double *)"""
        ret = self._wrap_call(self._vtk_obj.GetValues, *args)
        return ret

    def create_default_locator(self):
        """
        create_default_locator(self) -> None
        C++: void create_default_locator()
        Create default locator. Used to create one when none is
        specified. The locator is used to merge coincident points.
        """
        ret = self._vtk_obj.CreateDefaultLocator()
        return ret
        

    def generate_values(self, *args):
        """
        generate_values(self, __a:int, __b:[float, float]) -> None
        C++: void generate_values(int, double[2])
        generate_values(self, __a:int, __b:float, __c:float) -> None
        C++: void generate_values(int, double, double)"""
        ret = self._wrap_call(self._vtk_obj.GenerateValues, *args)
        return ret

    def set_strategy3d(self, *args):
        """
        set_strategy3d(self, _arg:int) -> None
        C++: virtual void set_strategy3d(int _arg)
        Set the contour strategy to apply. By default, strategy is
        USE_VOXELS. This method is time-efficient but can lead to bad
        results in the 3D case, where generated dual cells can be
        concave. USE_DECOMPOSED_POLYHEDRA allow better results in such
        cases (3D HTGs only). It takes advantage of the
        PolyhedronUtilities::Decompose method to generate better
        contours. The dowside is this method is much slower than
        USE_VOXELS.
        """
        ret = self._wrap_call(self._vtk_obj.SetStrategy3D, *args)
        return ret

    _updateable_traits_ = \
    (('use_implicit_arrays', 'GetUseImplicitArrays'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('number_of_contours',
    'GetNumberOfContours'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'use_implicit_arrays', 'abort_output',
    'number_of_contours', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HyperTreeGridContour, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HyperTreeGridContour properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['use_implicit_arrays'], [], ['abort_output',
            'number_of_contours', 'object_name']),
            title='Edit HyperTreeGridContour properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HyperTreeGridContour properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

