# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hyper_tree_grid_algorithm import HyperTreeGridAlgorithm


class HyperTreeGridFeatureEdges(HyperTreeGridAlgorithm):
    r"""
    HyperTreeGridFeatureEdges - Generates feature edges from an Hyper
    Tree Grid
    
    Superclass: HyperTreeGridAlgorithm
    
    HyperTreeGridFeatureEdges generates feature edges from an intput
    HyperTreeGrid. The nature of feature edges in the case of HTGs
    depends on the dimension of the HTG:
    - in 1D, it corresponds to the HTG geometry (HTG cells are already
      edges),
    - in 2D, it corresponds to border edges (HTG cells are quads),
    - in 3D, it corresponds to edges describing an angle in the HTG
      geometry (necessarily 90 degrees).
    
    Due to the nature of HTGs (T-Junctions), we cannot rely directly on
    the HTG geometry to construct feature edges. This filter iterates on
    the HTG to generate them on the fly.
    
    @sa
    FeatureEdges HyperTreeGrid HyperTreeGridAlgorithm
    HyperTreeGridGeometryFilter
    
    @par Thanks: This work was supported by Commissariat a l'Energie
    Atomique CEA, DAM, DIF, F-91297 Arpajon, France.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHyperTreeGridFeatureEdges, obj, update, **traits)
    
    merge_points = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        Turn on/off merging of coincident points using a locator. Note
        that when merging is on, points with different point attributes
        (e.g., normals) are merged, which may cause rendering artifacts.
        """
    )

    def _merge_points_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMergePoints,
                        self.merge_points)

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('merge_points', 'GetMergePoints'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'merge_points', 'object_name',
    'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HyperTreeGridFeatureEdges, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HyperTreeGridFeatureEdges properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'merge_points', 'object_name']),
            title='Edit HyperTreeGridFeatureEdges properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HyperTreeGridFeatureEdges properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

