# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class MarshalContext(Object):
    r"""
    MarshalContext - Shared context used by `Serializer` and
    `Deserializer`
    
    Superclass: Object
    
    This class is capable of tracking dependencies among VTK objects,
    their states and preventing recursion when the VTK serialization
    classes are used.
    
    It also provides centralized storage and tracking of objects in a
    weak object map, recording ownership of objects using a strong object
    map, hashing the contents of blobs to minimize data redundancies in
    the state and finally an API to coordinate the registration and
    removal of states, objects and blobs.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkMarshalContext, obj, update, **traits)
    
    def get_blob(self, *args):
        """
        get_blob(self, hash:str) -> TypeUInt8Array
        C++: SmartPointer<vtkTypeUInt8Array> get_blob(
            const std::string &hash)
        Find and get the `blob` registered at `hash`.
        """
        ret = self._wrap_call(self._vtk_obj.GetBlob, *args)
        return wrap_vtk(ret)

    def get_direct_dependencies(self, *args):
        """
        get_direct_dependencies(self, identifier:int) -> (int, ...)
        C++: std::vector<TypeUInt32> get_direct_dependencies(
            TypeUInt32 identifier)
        Return all direct dependencies of the object/state registered at
        `identifier`.
        
        ote This method doesn't compute the dependencies on demand.
        Instead it relies upon the `Serializer`/`vtkDeserializer`
        correctly using the `scoped_parent_tracker` API to record the
        genealogy of object(s)/state(s) serialized/deserialized.
        
        Technically, it's not a strict genealogy as it is possible to
        have circular dependencies.
        """
        ret = self._wrap_call(self._vtk_obj.GetDirectDependencies, *args)
        return ret

    def get_id(self, *args):
        """
        get_id(self, objectBase:ObjectBase) -> int
        C++: TypeUInt32 get_id(ObjectBase *objectBase)
        Get the `identifier` associated with `objectBase`.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetId, *my_args)
        return ret

    def get_object_at_id(self, *args):
        """
        get_object_at_id(self, identifier:int) -> ObjectBase
        C++: SmartPointer<vtkObjectBase> get_object_at_id(
            TypeUInt32 identifier)
        Find and get the `objectBase` registered at `identifier`.
        """
        ret = self._wrap_call(self._vtk_obj.GetObjectAtId, *args)
        return wrap_vtk(ret)

    def keep_alive(self, *args):
        """
        keep_alive(self, owner:str, objectBase:ObjectBase) -> None
        C++: void keep_alive(const std::string &owner,
            ObjectBase *objectBase)
        This method creates a record of ownership between `owner` and
        `objectBase`.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.KeepAlive, *my_args)
        return ret

    def make_id(self):
        """
        make_id(self) -> int
        C++: TypeUInt32 make_id()
        Make a new `identifier`.
        """
        ret = self._vtk_obj.MakeId()
        return ret
        

    def pop_parent(self):
        """
        pop_parent(self) -> None
        C++: void pop_parent()
        Adds the 'active' identifier into the genealogy. It's children
        are populated using the recorded children of the 'active'
        `identifier` using `add_child` The active parent is reset to the
        previous `identifier`.
        """
        ret = self._vtk_obj.PopParent()
        return ret
        

    def push_parent(self, *args):
        """
        push_parent(self, identifier:int) -> None
        C++: void push_parent(TypeUInt32 identifier)
        Make `identifier` the active identifier. All subsequent
        `add_child(child)` will add `child` into the list of children for
        `identifier` until `pop_parent` gets invoked.
        """
        ret = self._wrap_call(self._vtk_obj.PushParent, *args)
        return ret

    def register_blob(self, *args):
        """
        register_blob(self, blob:TypeUInt8Array, hash:str) -> bool
        C++: bool register_blob(SmartPointer<vtkTypeUInt8Array> blob,
            std::string &hash)
        Add a `blob` into the blob store associated with `hash`. If
        `hash` is an empty string, the contents of `blob` will be hashed
        and the result of the hashing algorithm stored in `hash`. Returns
        `true` if the `blob` was registered, `false` otherwise.
        
        ote The `blob` is successfully registered only if it is non-null.
        This method accepts empty blobs.
        """
        my_args = deref_array(args, [('vtkTypeUInt8Array', 'string')])
        ret = self._wrap_call(self._vtk_obj.RegisterBlob, *my_args)
        return ret

    def register_object(self, *args):
        """
        register_object(self, objectBase:ObjectBase, identifier:int)
            -> bool
        C++: bool register_object(ObjectBase *objectBase,
            TypeUInt32 &identifier)
        Add an `objectBase` into the weak object store associated with
        `identifier`. If `identifier` is 0, a new `identifier` will be
        created. Returns `true` if the `objectBase` was registered,
        `false` otherwise.
        
        ote The `objectBase` is successfully registered only if it is
        non-null.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.RegisterObject, *my_args)
        return ret

    def reset_direct_dependencies(self):
        """
        reset_direct_dependencies(self) -> None
        C++: void reset_direct_dependencies()
        Reset the dependency cache.
        """
        ret = self._vtk_obj.ResetDirectDependencies()
        return ret
        

    def reset_direct_dependencies_for_node(self, *args):
        """
        reset_direct_dependencies_for_node(self, identifier:int) -> None
        C++: void reset_direct_dependencies_for_node(TypeUInt32 identifier)
        Reset the dependency cache for the given `identifier`
        """
        ret = self._wrap_call(self._vtk_obj.ResetDirectDependenciesForNode, *args)
        return ret

    def retire(self, *args):
        """
        retire(self, owner:str, objectBase:ObjectBase) -> None
        C++: void retire(const std::string &owner,
            ObjectBase *objectBase)
        Release the strong reference kept by `owner` to the given
        `objectBase`.
        
        This method does nothing if the records show that `owner` doesn't
        own `objectBase`.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.Retire, *my_args)
        return ret

    def un_register_blob(self, *args):
        """
        un_register_blob(self, hash:str) -> bool
        C++: bool un_register_blob(const std::string &hash)
        Removes a `blob` registered at `hash` from the blob store.
        Returns `true` if a `blob` exists at `hash` and it was removed,
        `false` otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.UnRegisterBlob, *args)
        return ret

    def un_register_object(self, *args):
        """
        un_register_object(self, identifier:int) -> bool
        C++: bool un_register_object(TypeUInt32 identifier)
        Removes an `objectBase` registered at `identifier` from the weak
        object store. Returns `true` if a `objectBase` exists at
        `identifier` and it was removed, `false` otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.UnRegisterObject, *args)
        return ret

    def un_register_state(self, *args):
        """
        un_register_state(self, identifier:int) -> bool
        C++: bool un_register_state(TypeUInt32 identifier)
        Removes a `state`. Returns `true` if a `state` exists at
        `identifier` and it was removed, `false` otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.UnRegisterState, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(MarshalContext, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit MarshalContext properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit MarshalContext properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit MarshalContext properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

