# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.data_object_algorithm import DataObjectAlgorithm


class MergeBlocks(DataObjectAlgorithm):
    r"""
    MergeBlocks - merges blocks in a composite dataset to a dataset.
    
    Superclass: DataObjectAlgorithm
    
    MergeBlocks merges all blocks in a composite-dataset (rather any
    DataObjectTree subclass) into a dataset (either PolyData or
    UnstructuredGrid based on `vtkmerge_blocks::output_data_set_type`).
    
    If MergeBlocks::MergePartitionsOnly is true, then only
    PartitionedDataSet (and MultiPieceDataSet) blocks will be
    merged, thus largely preserving the tree structure.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkMergeBlocks, obj, update, **traits)
    
    merge_partitions_only = tvtk_base.false_bool_trait(desc=\
        r"""
        When set to true, only PartitionedDataSet and
        MultiPieceDataSet instances are merged into a since
        UnstructuredGrid leaving parent MultiBlockDataSet or
        PartitionedDataSetCollection structure largely unchanged.
        """
    )

    def _merge_partitions_only_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMergePartitionsOnly,
                        self.merge_partitions_only_)

    merge_points = tvtk_base.true_bool_trait(desc=\
        r"""
        Turn on/off merging of coincidental points.  Frontend to
        AppendFilter::MergePoints. Default is on.
        """
    )

    def _merge_points_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMergePoints,
                        self.merge_points_)

    tolerance_is_absolute = tvtk_base.false_bool_trait(desc=\
        r"""
        Get/Set whether Tolerance is treated as an absolute or relative
        tolerance. The default is to treat it as an absolute tolerance.
        """
    )

    def _tolerance_is_absolute_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetToleranceIsAbsolute,
                        self.tolerance_is_absolute_)

    output_data_set_type = traits.Int(4, enter_set=True, auto_set=False, desc=\
        r"""
        Get/Set the output type produced by this filter. Only blocks
        compatible with the output type will be merged in the output. For
        example, if the output type is PolyData, then blocks of type
        ImageData, StructuredGrid, etc. will not be merged - only
        PolyData can be merged into a PolyData. On the other hand,
        if the output type is UnstructuredGrid, then blocks of almost
        any type will be merged in the output. Valid values are
        VTK_POLY_DATA and VTK_UNSTRUCTURED_GRID defined in Type.h.
        Defaults to VTK_UNSTRUCTURED_GRID.
        """
    )

    def _output_data_set_type_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOutputDataSetType,
                        self.output_data_set_type)

    tolerance = traits.Trait(0.0, traits.Range(0.0, 1e+299, enter_set=True, auto_set=False), desc=\
        r"""
        Get/Set the tolerance to use to find coincident points when
        `merge_points` is `true`. Default is 0.0.
        
        This is simply passed on to the internal
        AppendFilter::vtkLocator used to merge points.
        @sa `Locator::set_tolerance`.
        """
    )

    def _tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTolerance,
                        self.tolerance)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('merge_partitions_only', 'GetMergePartitionsOnly'), ('merge_points',
    'GetMergePoints'), ('tolerance_is_absolute',
    'GetToleranceIsAbsolute'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('output_data_set_type', 'GetOutputDataSetType'), ('tolerance',
    'GetTolerance'), ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'merge_partitions_only', 'merge_points', 'release_data_flag',
    'tolerance_is_absolute', 'abort_output', 'object_name',
    'output_data_set_type', 'progress_text', 'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(MergeBlocks, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit MergeBlocks properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['merge_partitions_only', 'merge_points',
            'tolerance_is_absolute'], [], ['abort_output', 'object_name',
            'output_data_set_type', 'tolerance']),
            title='Edit MergeBlocks properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit MergeBlocks properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

