# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_algorithm import PolyDataAlgorithm


class OctreeImageToPointSetFilter(PolyDataAlgorithm):
    r"""
    OctreeImageToPointSetFilter - Convert an octree image to point set
    
    Superclass: PolyDataAlgorithm
    
    OctreeImageToPointSetFilter is a filter that converts an image
    with an octree unsigned char cell array to a pointset. Each bit of
    the unsigned char indicates if the cell had a point close to one of
    its 8 corners.
    
    It can optionally also output a point data array based on an input
    cell data scalar array by setting set_input_array_to_process. This array
    will have one of the components of the input array.
    
    @warning
    This class has been threaded with SMPTools. Using TBB or other
    non-sequential type (set in the CMake variable
    VTK_SMP_IMPLEMENTATION_TYPE) may improve performance significantly.
    
    @sa PointSetToOctreeImageFilter
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOctreeImageToPointSetFilter, obj, update, **traits)
    
    create_vertices_cell_array = tvtk_base.true_bool_trait(desc=\
        r"""
        Set/Get if a cell array of vertices will be created.
        
        The default is on.
        """
    )

    def _create_vertices_cell_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCreateVerticesCellArray,
                        self.create_vertices_cell_array_)

    process_input_cell_array = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get if array defined using set_input_array_to_process, which MUST
        be a cell data array, will be processed.
        
        The default is off.
        """
    )

    def _process_input_cell_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetProcessInputCellArray,
                        self.process_input_cell_array_)

    cell_array_component = traits.Trait(0, traits.Range(0, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the component of the input cell data array to process.
        
        The default is 0.
        """
    )

    def _cell_array_component_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCellArrayComponent,
                        self.cell_array_component)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('create_vertices_cell_array', 'GetCreateVerticesCellArray'),
    ('process_input_cell_array', 'GetProcessInputCellArray'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('cell_array_component', 'GetCellArrayComponent'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'create_vertices_cell_array', 'debug',
    'global_warning_display', 'process_input_cell_array',
    'release_data_flag', 'abort_output', 'cell_array_component',
    'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OctreeImageToPointSetFilter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OctreeImageToPointSetFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['create_vertices_cell_array', 'process_input_cell_array'], [],
            ['abort_output', 'cell_array_component', 'object_name']),
            title='Edit OctreeImageToPointSetFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OctreeImageToPointSetFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

