# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.widget_representation import WidgetRepresentation


class OrientationRepresentation(WidgetRepresentation):
    r"""
    OrientationRepresentation - a class defining the representation
    for the OrientationWidget
    
    Superclass: WidgetRepresentation
    
    This class is a concrete representation for the OrientationWidget.
    The widget is represented by three flat tori of different colors in
    each base direction (X/Y/Z). Additional arrows can be added to it for
    each direction in order to simplify grabbing and understanding. Their
    default look is a diamond shape, but they can be customized to look
    like real double arrows.
    
    To use this representation, you can use the place_widget() method to
    position the widget around an actor and scale it properly. You can
    retrieve orientation values with component-wise getters or through a
    Transform.
    
    @sa
    OrientationWidget
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOrientationRepresentation, obj, update, **traits)
    
    show_arrows = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get whether to show arrows. Default: False.
        """
    )

    def _show_arrows_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetShowArrows,
                        self.show_arrows_)

    arrow_distance = traits.Trait(0.0, traits.Range(0.0, 0.5, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the distance between arrows and torus. Clamped between
        [0.0, 0.5]. Default: 0.0.
        """
    )

    def _arrow_distance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArrowDistance,
                        self.arrow_distance)

    arrow_length = traits.Trait(0.05, traits.Range(0.01, 0.5, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the arrow length. This includes shaft+tip. Note that
        double arrows are two arrows next to each other. Clamped between
        [0.01, 0.5]. Default: 0.05.
        """
    )

    def _arrow_length_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArrowLength,
                        self.arrow_length)

    arrow_shaft_radius = traits.Trait(0.001, traits.Range(0.001, 0.5, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the radius of the arrow shaft. Clamped between [0.001,
        0.5]. Default: 0.001.
        """
    )

    def _arrow_shaft_radius_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArrowShaftRadius,
                        self.arrow_shaft_radius)

    arrow_tip_length = traits.Float(1.0, enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the length of the arrow tip. Factor of arrow length,
        equals if set to 1. Note that double arrows are two arrows next
        to each other. Clamped between [0.0, 1.0]. Default: 1.0.
        """
    )

    def _arrow_tip_length_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArrowTipLength,
                        self.arrow_tip_length)

    arrow_tip_radius = traits.Trait(0.03, traits.Range(0.001, 0.5, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the radius of the arrow tip. Clamped between [0.001,
        0.5]. Default: 0.03.
        """
    )

    def _arrow_tip_radius_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetArrowTipRadius,
                        self.arrow_tip_radius)

    interaction_state = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        The interaction state may be set from a widget (e.g.,
        OrientationWidget) or other object. This controls how the
        interaction with the widget proceeds. Normally this method is
        used as part of a handshaking process with the widget: First
        compute_interaction_state() is invoked that returns a state based
        on geometric considerations (i.e., cursor near a widget feature),
        then based on events, the widget may modify this further.
        """
    )

    def _interaction_state_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetInteractionState,
                        self.interaction_state)

    orientation = traits.Trait((traits.Undefined, traits.Undefined, traits.Undefined), traits.Array(shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3), enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the orientation values. Angles are in interval [-180,
        180] degrees.
        """
    )

    def _orientation_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrientation,
                        self.orientation)

    orientation_x = traits.Float(0.0, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _orientation_x_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrientationX,
                        self.orientation_x)

    orientation_y = traits.Float(-0.0, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _orientation_y_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrientationY,
                        self.orientation_y)

    orientation_z = traits.Float(0.0, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _orientation_z_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrientationZ,
                        self.orientation_z)

    def get_property(self, *args):
        """
        get_property(self, axis:int, selected:bool) -> Property
        C++: Property *get_property(int axis, bool selected)"""
        ret = self._wrap_call(self._vtk_obj.GetProperty, *args)
        return wrap_vtk(ret)

    def set_property(self, *args):
        """
        set_property(self, axis:int, selected:bool, property:Property)
            -> None
        C++: void set_property(int axis, bool selected,
            Property *property)
        Set/Get the properties values. Axis is clamped to axis values. If
        selected is true, applies to selected properties (on hover or
        click).
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetProperty, *my_args)
        return ret

    def get_property_x(self, *args):
        """
        get_property_x(self, selected:bool) -> Property
        C++: Property *get_property_x(bool selected)"""
        ret = self._wrap_call(self._vtk_obj.GetPropertyX, *args)
        return wrap_vtk(ret)

    def set_property_x(self, *args):
        """
        set_property_x(self, selected:bool, property:Property) -> None
        C++: void set_property_x(bool selected, Property *property)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetPropertyX, *my_args)
        return ret

    def get_property_y(self, *args):
        """
        get_property_y(self, selected:bool) -> Property
        C++: Property *get_property_y(bool selected)"""
        ret = self._wrap_call(self._vtk_obj.GetPropertyY, *args)
        return wrap_vtk(ret)

    def set_property_y(self, *args):
        """
        set_property_y(self, selected:bool, property:Property) -> None
        C++: void set_property_y(bool selected, Property *property)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetPropertyY, *my_args)
        return ret

    def get_property_z(self, *args):
        """
        get_property_z(self, selected:bool) -> Property
        C++: Property *get_property_z(bool selected)"""
        ret = self._wrap_call(self._vtk_obj.GetPropertyZ, *args)
        return wrap_vtk(ret)

    def set_property_z(self, *args):
        """
        set_property_z(self, selected:bool, property:Property) -> None
        C++: void set_property_z(bool selected, Property *property)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetPropertyZ, *my_args)
        return ret

    torus_length = traits.Trait(7.5, traits.Range(0.01, 100.0, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the length (Z scale) of the torus. This is a factor of
        Thickness parameter. Clamped between [0.01, 100.0]. Default: 7.5.
        """
    )

    def _torus_length_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTorusLength,
                        self.torus_length)

    torus_thickness = traits.Trait(0.005, traits.Range(0.001, 0.1, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the thickness of the torus. Thickness handles width in
        every axes. This means Length depends on it. Clamped between
        [0.001, 0.1]. Default: 0.005.
        """
    )

    def _torus_thickness_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTorusThickness,
                        self.torus_thickness)

    def _get_transform(self):
        return wrap_vtk(self._vtk_obj.GetTransform())
    transform = traits.Property(_get_transform, desc=\
        r"""
        Get the orientation transform.
        """
    )

    _updateable_traits_ = \
    (('show_arrows', 'GetShowArrows'), ('need_to_render',
    'GetNeedToRender'), ('picking_managed', 'GetPickingManaged'),
    ('dragable', 'GetDragable'), ('pickable', 'GetPickable'),
    ('use_bounds', 'GetUseBounds'), ('visibility', 'GetVisibility'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('arrow_distance', 'GetArrowDistance'),
    ('arrow_length', 'GetArrowLength'), ('arrow_shaft_radius',
    'GetArrowShaftRadius'), ('arrow_tip_length', 'GetArrowTipLength'),
    ('arrow_tip_radius', 'GetArrowTipRadius'), ('interaction_state',
    'GetInteractionState'), ('orientation_x', 'GetOrientationX'),
    ('orientation_y', 'GetOrientationY'), ('orientation_z',
    'GetOrientationZ'), ('torus_length', 'GetTorusLength'),
    ('torus_thickness', 'GetTorusThickness'), ('handle_size',
    'GetHandleSize'), ('place_factor', 'GetPlaceFactor'),
    ('estimated_render_time', 'GetEstimatedRenderTime'),
    ('render_time_multiplier', 'GetRenderTimeMultiplier'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'dragable', 'global_warning_display', 'need_to_render',
    'pickable', 'picking_managed', 'show_arrows', 'use_bounds',
    'visibility', 'arrow_distance', 'arrow_length', 'arrow_shaft_radius',
    'arrow_tip_length', 'arrow_tip_radius', 'estimated_render_time',
    'handle_size', 'interaction_state', 'object_name', 'orientation_x',
    'orientation_y', 'orientation_z', 'place_factor',
    'render_time_multiplier', 'torus_length', 'torus_thickness'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OrientationRepresentation, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OrientationRepresentation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['need_to_render', 'picking_managed', 'show_arrows',
            'use_bounds', 'visibility'], [], ['arrow_distance', 'arrow_length',
            'arrow_shaft_radius', 'arrow_tip_length', 'arrow_tip_radius',
            'estimated_render_time', 'handle_size', 'interaction_state',
            'object_name', 'orientation_x', 'orientation_y', 'orientation_z',
            'place_factor', 'render_time_multiplier', 'torus_length',
            'torus_thickness']),
            title='Edit OrientationRepresentation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OrientationRepresentation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

