# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_algorithm import PolyDataAlgorithm


class RecoverGeometryWireframe(PolyDataAlgorithm):
    r"""
    RecoverGeometryWireframe - Get corrected wireframe from
    tessellated facets
    
    Superclass: PolyDataAlgorithm
    
    This filter create an edge mask that is used at render time to ignore
    the rendering of specific edges in wireframe mode. For that it checks
    a cell attribute so that each adjacent cells having the same
    attribute value will not display an edge between them.
    
    The main usage of this filter is at the output of
    DataSetSurfaceFilter or GeometryFilter, when we are subdividing
    non-linear cells but we still want to visualize the edges of the
    original cells. In this case the cell attribute will usually be the
    original cell id values.
    
    @warning As the edge flag mechanism does not allow to specify a
        single edge
    from a point the filter might duplicate some points, so topology is
    not preserved.
    
    @sa
    DataSetSurfaceFilter
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkRecoverGeometryWireframe, obj, update, **traits)
    
    cell_ids_attribute = traits.String('', enter_set=True, auto_set=False, desc=\
        r"""
        Get/Set the cell attribute name that will be used to discriminate
        edges that should be kept from edges that shouldn't. This array
        should be a IdType array.
        
        Default is empty.
        """
    )

    def _cell_ids_attribute_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCellIdsAttribute,
                        self.cell_ids_attribute)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('cell_ids_attribute', 'GetCellIdsAttribute'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'cell_ids_attribute',
    'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(RecoverGeometryWireframe, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit RecoverGeometryWireframe properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'cell_ids_attribute', 'object_name']),
            title='Edit RecoverGeometryWireframe properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit RecoverGeometryWireframe properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

