# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_algorithm import PolyDataAlgorithm


class StaticCleanPolyData(PolyDataAlgorithm):
    r"""
    StaticCleanPolyData - merge duplicate points, and/or remove unused
    points and/or remove degenerate cells
    
    Superclass: PolyDataAlgorithm
    
    StaticCleanPolyData is a filter that takes polygonal data as input
    and generates polygonal data as output. StaticCleanPolyData will
    merge duplicate points (within specified tolerance), and if enabled,
    transform degenerate cells into appropriate forms (for example, a
    triangle is converted into a line if two points of triangle are
    merged).
    
    Conversion of degenerate cells is controlled by the flags
    convert_lines_to_points, convert_polys_to_lines, convert_strips_to_polys which
    act cumulatively such that a degenerate strip may become a poly. The
    full set is Line with 1 points -> Vert (if convert_lines_to_points) Poly
    with 2 points -> Line (if convert_polys_to_lines) Poly with 1 points ->
    Vert (if convert_polys_to_lines && convert_lines_to_points) Strp with 3
    points -> Poly (if convert_strips_to_polys) Strp with 2 points -> Line
    (if convert_strips_to_polys && convert_polys_to_lines) Strp with 1 points
    -> Vert (if convert_strips_to_polys && convert_polys_to_lines
      && convert_lines_to_points)
    
    Internally this class uses StaticPointLocator, which is a
    threaded, and much faster locator (especially for large data) than
    the incremental locators that CleanPolyData uses. Note because of
    these and other differences, the output of this filter may be
    different than CleanPolyData.
    
    @warning
    Merging points can alter topology, including introducing non-manifold
    forms. The tolerance should be chosen carefully to avoid these
    problems. Large tolerances (of size > locator bin width) may generate
    poor results.
    
    @warning
    Unlike CleanPolyData, point merging is always performed (i.e.,
    there is no point_merging_off()).
    
    @warning
    Unlike CleanPolyData, conversion from one cell type to another is
    disabled/off. This produces more predictable behavior in many
    applications.
    
    @warning
    The StaticCleanPolyData filter is similar in operation to
    CleanPolyData. However, StaticCleanPolyData is non-incremental
    and uses a much faster (especially for larger datasets) threading
    approach and when merging points with a non-zero tolerance. However
    because of the difference in the traversal order in the point merging
    process, the output of the filters may be different.
    
    @warning
    This class has been threaded with SMPTools. Using TBB or other
    non-sequential type (set in the CMake variable
    VTK_SMP_IMPLEMENTATION_TYPE) may improve performance significantly.
    
    @sa
    CleanPolyData StaticCleanUnstructuredGrid
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkStaticCleanPolyData, obj, update, **traits)
    
    average_point_data = tvtk_base.false_bool_trait(desc=\
        r"""
        Indicate whether point coordinates and point data of merged
        points are averaged. By default, the point coordinates and
        attribute data are not averaged, and the point coordinate and
        data of the single, remaining merged point is retained.
        Otherwise, the data coordinates and attribute values of all
        merged points are averaged. By default this feature is disabled.
        """
    )

    def _average_point_data_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAveragePointData,
                        self.average_point_data_)

    convert_lines_to_points = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off conversion of degenerate lines to points. Default is
        Off.
        """
    )

    def _convert_lines_to_points_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetConvertLinesToPoints,
                        self.convert_lines_to_points_)

    convert_polys_to_lines = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off conversion of degenerate polys to lines. Default is
        Off.
        """
    )

    def _convert_polys_to_lines_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetConvertPolysToLines,
                        self.convert_polys_to_lines_)

    convert_strips_to_polys = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off conversion of degenerate strips to polys. Default is
        Off.
        """
    )

    def _convert_strips_to_polys_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetConvertStripsToPolys,
                        self.convert_strips_to_polys_)

    piece_invariant = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _piece_invariant_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPieceInvariant,
                        self.piece_invariant_)

    produce_merge_map = tvtk_base.false_bool_trait(desc=\
        r"""
        Indicate whether a merge map should be produced on output. The
        merge map, if requested, maps each input point to its output
        point id, or provides a value of -1 if the input point is not
        used in the output. The merge map is associated with the filter's
        output field data and is named "point_merge_map". By default,
        produce_merge_map is disabled.
        """
    )

    def _produce_merge_map_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetProduceMergeMap,
                        self.produce_merge_map_)

    remove_unused_points = tvtk_base.true_bool_trait(desc=\
        r"""
        Indicate whether points unused by any cell are removed from the
        output. By default this point removal is on. Note that when this
        is off, the filter can successfully process datasets with no
        cells (and just points). If on, and there are no cells, than the
        output will be empty.
        """
    )

    def _remove_unused_points_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRemoveUnusedPoints,
                        self.remove_unused_points_)

    tolerance_is_absolute = tvtk_base.false_bool_trait(desc=\
        r"""
        By default tolerance_is_absolute is false and Tolerance is a
        fraction of Bounding box diagonal, if true, absolute_tolerance is
        used when adding points to locator (merging)
        """
    )

    def _tolerance_is_absolute_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetToleranceIsAbsolute,
                        self.tolerance_is_absolute_)

    absolute_tolerance = traits.Trait(0.0, traits.Range(0.0, 1e+299, enter_set=True, auto_set=False), desc=\
        r"""
        Specify tolerance in absolute terms. Default is 1.0.
        """
    )

    def _absolute_tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAbsoluteTolerance,
                        self.absolute_tolerance)

    merging_array = traits.String('', enter_set=True, auto_set=False, desc=\
        r"""
        Specify the name of a point data array associated with the point
        merging process. If a data array is specified, and exists in the
        input point data, then point merging will switch into a mode
        where merged points must be both geometrically coincident and
        have matching point data (i.e., an exact match of position and
        data - tolerances have no effect). Note that the number of tuples
        in the merging data array must be equal to the number of points
        in the input. By default, no data array is associated with the
        input points (i.e., the name of the data array is empty).
        """
    )

    def _merging_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMergingArray,
                        self.merging_array)

    output_points_precision = traits.Int(2, enter_set=True, auto_set=False, desc=\
        r"""
        Set/get the desired precision for the output types. See the
        documentation for the Algorithm::DesiredOutputPrecision enum
        for an explanation of the available precision settings.
        """
    )

    def _output_points_precision_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOutputPointsPrecision,
                        self.output_points_precision)

    tolerance = traits.Trait(0.0, traits.Range(0.0, 1.0, enter_set=True, auto_set=False), desc=\
        r"""
        Specify tolerance in terms of fraction of bounding box length. 
        Default is 0.0. This takes effect only if tolerance_is_absolute is
        false.
        """
    )

    def _tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTolerance,
                        self.tolerance)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def _get_locator(self):
        return wrap_vtk(self._vtk_obj.GetLocator())
    locator = traits.Property(_get_locator, desc=\
        r"""
        Retrieve the internal locator to manually configure it, for
        example specifying the number of points per bucket, or
        controlling the traversal order. This method is generally used
        for debugging or testing purposes.
        """
    )

    _updateable_traits_ = \
    (('average_point_data', 'GetAveragePointData'),
    ('convert_lines_to_points', 'GetConvertLinesToPoints'),
    ('convert_polys_to_lines', 'GetConvertPolysToLines'),
    ('convert_strips_to_polys', 'GetConvertStripsToPolys'),
    ('piece_invariant', 'GetPieceInvariant'), ('produce_merge_map',
    'GetProduceMergeMap'), ('remove_unused_points',
    'GetRemoveUnusedPoints'), ('tolerance_is_absolute',
    'GetToleranceIsAbsolute'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('absolute_tolerance', 'GetAbsoluteTolerance'), ('merging_array',
    'GetMergingArray'), ('output_points_precision',
    'GetOutputPointsPrecision'), ('tolerance', 'GetTolerance'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'average_point_data', 'convert_lines_to_points',
    'convert_polys_to_lines', 'convert_strips_to_polys', 'debug',
    'global_warning_display', 'piece_invariant', 'produce_merge_map',
    'release_data_flag', 'remove_unused_points', 'tolerance_is_absolute',
    'abort_output', 'absolute_tolerance', 'merging_array', 'object_name',
    'output_points_precision', 'progress_text', 'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(StaticCleanPolyData, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit StaticCleanPolyData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['average_point_data', 'convert_lines_to_points',
            'convert_polys_to_lines', 'convert_strips_to_polys',
            'piece_invariant', 'produce_merge_map', 'remove_unused_points',
            'tolerance_is_absolute'], [], ['abort_output', 'absolute_tolerance',
            'merging_array', 'object_name', 'output_points_precision',
            'tolerance']),
            title='Edit StaticCleanPolyData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit StaticCleanPolyData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

