# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.abstract_point_locator import AbstractPointLocator


class StaticPointLocator(AbstractPointLocator):
    r"""
    StaticPointLocator - quickly locate points in 3-space
    
    Superclass: AbstractPointLocator
    
    StaticPointLocator is a spatial search object to quickly locate
    points in 3D.  StaticPointLocator works by dividing a specified
    region of space into a regular array of cuboid buckets, and then
    keeping a list of points that lie in each bucket. Typical operation
    involves giving a position in 3D and finding the closest point; or
    finding the N closest points.
    
    StaticPointLocator is an accelerated version of PointLocator.
    It is threaded (via SMPTools), and supports one-time static
    construction (i.e., incremental point insertion is not supported). If
    you need to incrementally insert points, use the PointLocator or
    its kin to do so.
    
    @warning
    This class is templated. It may run slower than serial execution if
    the code is not optimized during compilation. Build in Release or
    release_with_debug_info.
    
    @warning
    Make sure that you review the documentation for the superclasses
    AbstactPointLocator and Locator. In particular the Automatic
    data member can be used to automatically determine divisions based on
    the average number of points per bucket.
    
    @warning
    Other types of spatial locators have been developed such as octrees
    and kd-trees. These are often more efficient for the operations
    described here.
    
    @warning
    Frequently StaticPointLocator is used in lieu of PointLocator.
    They are very similar in terms of algorithmic approach, however
    StaticCellLocator is threaded and is typically much faster for a
    large number of points (on the order of 3-5x faster). For small
    numbers of points, PointLocator is just as fast as
    StaticPointLocator.
    
    @sa
    PointLocator CellLocator Locator AbstractPointLocator
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkStaticPointLocator, obj, update, **traits)
    
    traversal_order = tvtk_base.RevPrefixMap({'bin_order': 1, 'point_order': 0}, default_value='bin_order', desc=\
        r"""
        Specify the manner in which points are processed when a non-zero
        merge tolerance is specified. By default, BIN_ORDER is used
        (i.e., threaded using bin checkerboard traversal) versus
        POINT_ORDER, which is a serial traversal.
        """
    )

    def _traversal_order_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTraversalOrder,
                        self.traversal_order_)

    divisions = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(50, 50, 50), cols=3, desc=\
        r"""
        Set the number of divisions in x-y-z directions. If the Automatic
        data member is enabled, the Divisions are set according to the
        number_of_points_per_bucket and max_number_of_buckets data members. The
        number of divisions must be >= 1 in each direction.
        """
    )

    def _divisions_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDivisions,
                        self.divisions)

    max_number_of_buckets = traits.Trait(2147483647, traits.Range(1000, 9223372036854775807, enter_set=True, auto_set=False), desc=\
        r"""
        Set the maximum number of buckets in the locator. By default the
        value is set to VTK_INT_MAX. Note that there are significant
        performance implications at work here. If the number of buckets
        is set very large (meaning > VTK_INT_MAX) then internal sorting
        may be performed using 64-bit integers (which is much slower than
        using a 32-bit int). Of course, memory requirements may
        dramatically increase as well.  It is recommended that the
        default value be used; but for extremely large data it may be
        desired to create a locator with an exceptionally large number of
        buckets. Note also that during initialization of the locator if
        the max_number_of_buckets threshold is exceeded, the Divisions are
        scaled down in such a way as not to exceed the max_number_of_buckets
        proportionally to the size of the bounding box in the x-y-z
        directions.
        """
    )

    def _max_number_of_buckets_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMaxNumberOfBuckets,
                        self.max_number_of_buckets)

    number_of_points_per_bucket = traits.Trait(1, traits.Range(1, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Specify the average number of points in each bucket. This data
        member is used in conjunction with the Automatic data member (if
        enabled) to determine the number of locator x-y-z divisions.
        """
    )

    def _number_of_points_per_bucket_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfPointsPerBucket,
                        self.number_of_points_per_bucket)

    def get_bucket_ids(self, *args):
        """
        get_bucket_ids(self, bNum:int, bList:IdList) -> None
        C++: void get_bucket_ids(IdType bNum, IdList *bList)
        Given a bucket number bNum between 0 <= bNum <
        this->get_number_of_buckets(), return a list of point ids contained
        within the bucket. The user must provide an instance of IdList
        to contain the result.
        """
        my_args = deref_array(args, [('int', 'vtkIdList')])
        ret = self._wrap_call(self._vtk_obj.GetBucketIds, *my_args)
        return ret

    def _get_large_ids(self):
        return self._vtk_obj.GetLargeIds()
    large_ids = traits.Property(_get_large_ids, desc=\
        r"""
        Inform the user as to whether large ids are being used. This flag
        only has meaning after the locator has been built. Large ids are
        used when the number of binned points, or the number of bins, is
        >= the maximum number of buckets (specified by the user). Note
        that large_ids are only available on 64-bit architectures.
        """
    )

    def get_number_of_points_in_bucket(self, *args):
        """
        get_number_of_points_in_bucket(self, bNum:int) -> int
        C++: IdType get_number_of_points_in_bucket(IdType bNum)
        Given a bucket number bNum between 0 <= bNum <
        this->get_number_of_buckets(), return the number of points found in
        the bucket.
        """
        ret = self._wrap_call(self._vtk_obj.GetNumberOfPointsInBucket, *args)
        return ret

    def _get_spacing(self):
        return self._vtk_obj.GetSpacing()
    spacing = traits.Property(_get_spacing, desc=\
        r"""
        Provide an accessor to the bucket spacing. Valid after the
        locator is built.
        """
    )

    def get_spacing(self, *args):
        """
        get_spacing(self) -> Pointer
        C++: virtual double *get_spacing()
        get_spacing(self, spacing:[float, float, float]) -> None
        C++: virtual void get_spacing(double spacing[3])
        Provide an accessor to the bucket spacing. Valid after the
        locator is built.
        """
        ret = self._wrap_call(self._vtk_obj.GetSpacing, *args)
        return ret

    def intersect_with_line(self, *args):
        """
        intersect_with_line(self, a0:[float, float, float], a1:[float,
            float, float], tol:float, t:float, lineX:[float, float,
            float], ptX:[float, float, float], ptId:int) -> int
        C++: int intersect_with_line(double a0[3], double a1[3], double tol,
             double &t, double lineX[3], double ptX[3], IdType &ptId)
        Intersect the points contained in the locator with the line
        defined by (a0,a1). Return the point within the tolerance tol
        that is closest to a0 (tol measured in the world coordinate
        system). If an intersection occurs (i.e., the method returns
        nonzero), then the parametric location along the line t, the
        closest position along the line lineX, and the coordinates of the
        picked ptId is returned in ptX. (This method is thread safe after
        the locator is built.)
        """
        ret = self._wrap_call(self._vtk_obj.IntersectWithLine, *args)
        return ret

    def merge_points(self, *args):
        """
        merge_points(self, tol:float, mergeMap:[int, ...]) -> None
        C++: void merge_points(double tol, IdType *mergeMap)
        Merge points in the locator given a tolerance. Return a merge map
        which maps all points to the points to which they were merged.
        Note the number of points in the merge map is the number of
        points the locator was built with. The user is expected to pass
        in an allocated mergeMap. Note that when tol!=0, the traversal
        order of threading can be specified using the set_traversal_order()
        method. The traversal order is needed to generate deterministic
        output (i.e., output independent of thread execution order).
        """
        ret = self._wrap_call(self._vtk_obj.MergePoints, *args)
        return ret

    def merge_points_with_data(self, *args):
        """
        merge_points_with_data(self, data:DataArray, mergeMap:[int, ...])
            -> None
        C++: void merge_points_with_data(DataArray *data,
            IdType *mergeMap)
        Merge points and associated data in the locator. Return a merge
        map which maps all points to the points to which they were
        merged. Note the number of points in the merge map is the number
        of points the locator was built with. Merging occurs when both
        the points and the associated point data (represented by the data
        array) are equal. The user is expected to pass in an allocated
        mergeMap, and the size of the data array should be number of
        points in the locator. The data array may have an arbitrary
        number of components.
        """
        my_args = deref_array(args, [('vtkDataArray', ['int', Ellipsis])])
        ret = self._wrap_call(self._vtk_obj.MergePointsWithData, *my_args)
        return ret

    _updateable_traits_ = \
    (('automatic', 'GetAutomatic'), ('use_existing_search_structure',
    'GetUseExistingSearchStructure'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('traversal_order', 'GetTraversalOrder'), ('divisions',
    'GetDivisions'), ('max_number_of_buckets', 'GetMaxNumberOfBuckets'),
    ('number_of_points_per_bucket', 'GetNumberOfPointsPerBucket'),
    ('max_level', 'GetMaxLevel'), ('tolerance', 'GetTolerance'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['automatic', 'debug', 'global_warning_display',
    'use_existing_search_structure', 'traversal_order', 'divisions',
    'max_level', 'max_number_of_buckets', 'number_of_points_per_bucket',
    'object_name', 'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(StaticPointLocator, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit StaticPointLocator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['automatic', 'use_existing_search_structure'],
            ['traversal_order'], ['divisions', 'max_level',
            'max_number_of_buckets', 'number_of_points_per_bucket', 'object_name',
            'tolerance']),
            title='Edit StaticPointLocator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit StaticPointLocator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

