# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.data_set_algorithm import DataSetAlgorithm


class TensorPrincipalInvariants(DataSetAlgorithm):
    r"""
    TensorPrincipalInvariants - Compute principal values and
    directions from symmetric tensor
    
    Superclass: DataSetAlgorithm
    
    This filter computes principal values and vectors of symmetric
    tensors. The principal values are ordered from largest to smallest.
    The principal vectors can be scaled with the principal values.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkTensorPrincipalInvariants, obj, update, **traits)
    
    scale_vectors = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _scale_vectors_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleVectors,
                        self.scale_vectors)

    def _get_cell_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetCellDataArraySelection())
    cell_data_array_selection = traits.Property(_get_cell_data_array_selection, desc=\
        r"""
        Access the cell data array selection that specifies which cell
        data arrays should have their principal invariants computed.
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    def _get_point_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetPointDataArraySelection())
    point_data_array_selection = traits.Property(_get_point_data_array_selection, desc=\
        r"""
        Access the point data array selection that specifies which point
        data arrays should have their principal invariants computed.
        """
    )

    def get_sigma_value_array_name(self, *args):
        """
        get_sigma_value_array_name(baseName:str, index:int) -> str
        C++: static std::string get_sigma_value_array_name(
            const std::string &baseName, int index)
        Return the given array name with a suffix for principal values
        attached.
        """
        ret = self._wrap_call(self._vtk_obj.GetSigmaValueArrayName, *args)
        return ret

    def get_sigma_vector_array_name(self, *args):
        """
        get_sigma_vector_array_name(baseName:str, index:int) -> str
        C++: static std::string get_sigma_vector_array_name(
            const std::string &baseName, int index)
        Return the given array name with a suffix for principal vectors
        attached.
        """
        ret = self._wrap_call(self._vtk_obj.GetSigmaVectorArrayName, *args)
        return ret

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('scale_vectors', 'GetScaleVectors'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text',
    'scale_vectors'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(TensorPrincipalInvariants, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit TensorPrincipalInvariants properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'object_name', 'scale_vectors']),
            title='Edit TensorPrincipalInvariants properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit TensorPrincipalInvariants properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

