# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.to_implicit_strategy import ToImplicitStrategy


class ToImplicitRamerDouglasPeuckerStrategy(ToImplicitStrategy):
    r"""
    ToImplicitRamerDouglasPeuckerStrategy - A strategy for creating
    constant or affine by parts implicit arrays from explicit memory
    arrays based on the Ramer-Douglas-Peucker algorithm(*).
    
    Superclass: ToImplicitStrategy
    
    (*)References:
    - https://en.wikipedia.org/wiki/Ramer%E2%80%93Douglas%E2%80%93Peucker_
      algorithm
    - https://cartography-playground.gitlab.io/playgrounds/douglas-peucker
      -algorithm/
    - Urs Ramer, An iterative procedure for the polygonal approximation
      of plane curves, Computer Graphics and Image Processing, Volume 1,
      Issue 3, 1972, Pages 244-256, ISSN 0146-664X,
      https://doi.org/10.1016/S0146-664X(72)80017-0.
      (https://www.sciencedirect.com/science/article/pii/s0146664x72800170
      )
    - DOUGLAS, DAVID & PEUCKER, THOMAS. (1973). Algorithms for the
      Reduction of the Number of Points Required to Represent a Digitized
    Line or Its Caricature. Cartographica: The International Journal for
      Geographic Information and Geovisualization. 10. 112-122.
      10.3138/FM57-6770-U75U-7727.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkToImplicitRamerDouglasPeuckerStrategy, obj, update, **traits)
    
    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('tolerance', 'GetTolerance'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name', 'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ToImplicitRamerDouglasPeuckerStrategy, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ToImplicitRamerDouglasPeuckerStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name', 'tolerance']),
            title='Edit ToImplicitRamerDouglasPeuckerStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ToImplicitRamerDouglasPeuckerStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

