# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class UnstructuredGridFieldAnnotations(Object):
    r"""
    UnstructuredGridFieldAnnotations - Fetch/add field annotations
    from/to an unstructured grid's field data.
    
    Superclass: Object
    
    Takes partitioned dataset collection (or a single unstructured grid)
    as input and parses (or adds) field-data records as annotations that
    can be used to improve conversion to (or from) a CellGrid.
    
    This field data is currently added by IOSSReader. The
    IOSSCellGridReader and DGTranscribeUnstructuredCells both use
    this class.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkUnstructuredGridFieldAnnotations, obj, update, **traits)
    
    def add_annotations(self, *args):
        """
        add_annotations(self, fieldData:FieldData,
            assembly:DataAssembly) -> None
        C++: virtual void add_annotations(FieldData *fieldData,
            DataAssembly *assembly)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.AddAnnotations, *my_args)
        return ret

    def fetch_annotations(self, *args):
        """
        fetch_annotations(self, fieldData:FieldData,
            assembly:DataAssembly) -> None
        C++: virtual void fetch_annotations(FieldData *fieldData,
            DataAssembly *assembly)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.FetchAnnotations, *my_args)
        return ret

    def reset(self):
        """
        reset(self) -> None
        C++: virtual void reset()"""
        ret = self._vtk_obj.Reset()
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(UnstructuredGridFieldAnnotations, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit UnstructuredGridFieldAnnotations properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit UnstructuredGridFieldAnnotations properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit UnstructuredGridFieldAnnotations properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

