# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.partitioned_data_set_collection_algorithm import PartitionedDataSetCollectionAlgorithm


class UnstructuredGridToCellGrid(PartitionedDataSetCollectionAlgorithm):
    r"""
    UnstructuredGridToCellGrid - Create a cell-grid that approximates
    a collection of UnstructuredGrids.
    
    Superclass: PartitionedDataSetCollectionAlgorithm
    
    This filter takes a partitioned dataset collection (or a single
    unstructured grid) as input, iterates each block's cells to find the
    shapes and orders of cells present; then it creates empty
    CellGrids and runs its internal transcribe_query to construct cells
    and cell-attributes to match each input unstructured-grid.
    
    Note that this filter assumes all the cells of the same shape in the
    UnstructuredGrid are of the same order. This matches assumptions
    in the IOSS reader but may not be true of arbitrary unstructured
    grids.
    
    ## Design notes
    
    Even though this filter is named as though it processes a single
    unstructured grid at a time, it is multiblock aware (and indeed,
    always outputs a partitioned dataset collection). This was done in
    order to properly handle IOSS data, which includes metadata on the
    parent composite dataset that is relevant to conversions of
    individual child objects it contains.
    
    There is no reason – apart from the development time required –
    that this filter couldn't accept any DataSet as input (rather than
    just unstructured grids). However, without some analogs to structured
    dataset types, this would generally perform poorly. A set of spline
    cells would make representing many structured datasets
    space-efficient and amenable to smoothing/simplification.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkUnstructuredGridToCellGrid, obj, update, **traits)
    
    def add_preferred_output_type(self, *args):
        """
        add_preferred_output_type(self, inputCellType:int,
            preferredOutputType:StringToken, priority:int) -> None
        C++: virtual void add_preferred_output_type(int inputCellType,
            StringToken preferredOutputType, int priority)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.AddPreferredOutputType, *my_args)
        return ret

    def reset(self):
        """
        reset(self) -> None
        C++: virtual void reset()"""
        ret = self._vtk_obj.Reset()
        return ret
        

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(UnstructuredGridToCellGrid, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit UnstructuredGridToCellGrid properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'object_name']),
            title='Edit UnstructuredGridToCellGrid properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit UnstructuredGridToCellGrid properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

