# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class UnstructuredGridVolumeRayIntegrator(Object):
    r"""
    UnstructuredGridVolumeRayIntegrator - a superclass for volume ray
    integration functions
    
    Superclass: Object
    
    UnstructuredGridVolumeRayIntegrator is a superclass for ray
    integration functions that can be used within a
    UnstructuredGridVolumeRayCastMapper.
    
    @sa
    UnstructuredGridVolumeRayCastMapper
    UnstructuredGridVolumeRayCastFunction
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkUnstructuredGridVolumeRayIntegrator, obj, update, **traits)
    
    def initialize(self, *args):
        """
        initialize(self, volume:Volume, scalars:DataArray) -> None
        C++: virtual void initialize(Volume *volume,
            DataArray *scalars)
        Set up the integrator with the given properties and scalars.
        """
        my_args = deref_array(args, [('vtkVolume', 'vtkDataArray')])
        ret = self._wrap_call(self._vtk_obj.Initialize, *my_args)
        return ret

    def integrate(self, *args):
        """
        integrate(self, intersectionLengths:DoubleArray,
            nearIntersections:DataArray, farIntersections:DataArray,
             color:[float, float, float, float]) -> None
        C++: virtual void integrate(DoubleArray *intersectionLengths,
            DataArray *nearIntersections,
            DataArray *farIntersections, float color[4])
        Given a set of intersections (defined by the three arrays),
        compute the piecewise integration of the array in front to back
        order. /c intersectionLengths holds the lengths of each piecewise
        segment. /c nearIntersections and /c farIntersections hold the
        scalar values at the front and back of each segment.  /c color
        should contain the RGBA value of the volume in front of the
        segments passed in, and the result will be placed back into /c
        color.
        """
        my_args = deref_array(args, [('vtkDoubleArray', 'vtkDataArray', 'vtkDataArray', ['float', 'float', 'float', 'float'])])
        ret = self._wrap_call(self._vtk_obj.Integrate, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(UnstructuredGridVolumeRayIntegrator, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit UnstructuredGridVolumeRayIntegrator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit UnstructuredGridVolumeRayIntegrator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit UnstructuredGridVolumeRayIntegrator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

