# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.widget_representation import WidgetRepresentation


class VRMenuRepresentation(WidgetRepresentation):
    r"""
    VRMenuRepresentation - Widget representation for VRMenuWidget
    
    Superclass: WidgetRepresentation
    
    Implementation of the popup panel representation for the
    VRMenuWidget. This representation is rebuilt every time the
    selected/hovered prop changes. Its position is set according to the
    camera orientation and is placed at a distance defined in meters in
    the build_representation() method.
    
    WARNING: The panel might be occluded by other props.
      TODO: Improve placement method.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkVRMenuRepresentation, obj, update, **traits)
    
    def _get_current_option(self):
        return self._vtk_obj.GetCurrentOption()
    current_option = traits.Property(_get_current_option, desc=\
        r"""
        
        """
    )

    def push_front_menu_item(self, *args):
        """
        push_front_menu_item(self, name:str, text:str, cmd:Command)
            -> None
        C++: void push_front_menu_item(const char *name, const char *text,
            Command *cmd)
        Methods to add/remove items to the menu, called by the menu
        widget
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.PushFrontMenuItem, *my_args)
        return ret

    def remove_all_menu_items(self):
        """
        remove_all_menu_items(self) -> None
        C++: void remove_all_menu_items()"""
        ret = self._vtk_obj.RemoveAllMenuItems()
        return ret
        

    def remove_menu_item(self, *args):
        """
        remove_menu_item(self, name:str) -> None
        C++: void remove_menu_item(const char *name)"""
        ret = self._wrap_call(self._vtk_obj.RemoveMenuItem, *args)
        return ret

    def rename_menu_item(self, *args):
        """
        rename_menu_item(self, name:str, text:str) -> None
        C++: void rename_menu_item(const char *name, const char *text)"""
        ret = self._wrap_call(self._vtk_obj.RenameMenuItem, *args)
        return ret

    _updateable_traits_ = \
    (('need_to_render', 'GetNeedToRender'), ('picking_managed',
    'GetPickingManaged'), ('dragable', 'GetDragable'), ('pickable',
    'GetPickable'), ('use_bounds', 'GetUseBounds'), ('visibility',
    'GetVisibility'), ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('handle_size', 'GetHandleSize'),
    ('place_factor', 'GetPlaceFactor'), ('estimated_render_time',
    'GetEstimatedRenderTime'), ('render_time_multiplier',
    'GetRenderTimeMultiplier'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'dragable', 'global_warning_display', 'need_to_render',
    'pickable', 'picking_managed', 'use_bounds', 'visibility',
    'estimated_render_time', 'handle_size', 'object_name', 'place_factor',
    'render_time_multiplier'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(VRMenuRepresentation, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit VRMenuRepresentation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['need_to_render', 'picking_managed', 'use_bounds',
            'visibility'], [], ['estimated_render_time', 'handle_size',
            'object_name', 'place_factor', 'render_time_multiplier']),
            title='Edit VRMenuRepresentation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit VRMenuRepresentation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

