# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.win32_open_gl_render_window import Win32OpenGLRenderWindow


class Win32OpenGLDXRenderWindow(Win32OpenGLRenderWindow):
    r"""
    Win32OpenGLDXRenderWindow - VTK render window providing
    open_gl-DirectX interop
    
    Superclass: Win32OpenGLRenderWindow
    
    This Win32OpenGLRenderWindow subclass allows for rendering in a
    texture that is shared between an open_gl and a D3D context, using the
    NVidia NV_DX_interop extension.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkWin32OpenGLDXRenderWindow, obj, update, **traits)
    
    shared_texture_samples = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Set / Get the number of multisamples used by shared textures for
        hardware antialiasing.
        """
    )

    def _shared_texture_samples_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSharedTextureSamples,
                        self.shared_texture_samples)

    size = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(0, 0), cols=2, desc=\
        r"""
        Overridden to resize the internal D3D shared texture
        """
    )

    def _size_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSize,
                        self.size)

    def blit_to_texture(self, *args):
        """
        blit_to_texture(self, color:Pointer, depth:Pointer=...) -> None
        C++: void blit_to_texture(void *color, void *depth=nullptr)"""
        ret = self._wrap_call(self._vtk_obj.BlitToTexture, *args)
        return ret

    def lock(self):
        """
        lock(self) -> None
        C++: void lock()
        Lock/Unlock the shared texture. The texture must be locked before
        rendering into it.
        """
        ret = self._vtk_obj.Lock()
        return ret
        

    def register_shared_display_framebuffer(self):
        """
        register_shared_display_framebuffer(self) -> None
        C++: void register_shared_display_framebuffer()
        Register the display_framebuffer of this window as a D3D shared
        texture
        """
        ret = self._vtk_obj.RegisterSharedDisplayFramebuffer()
        return ret
        

    def register_shared_render_framebuffer(self):
        """
        register_shared_render_framebuffer(self) -> None
        C++: void register_shared_render_framebuffer()
        Register the render_framebuffer of this window as a D3D shared
        texture
        """
        ret = self._vtk_obj.RegisterSharedRenderFramebuffer()
        return ret
        

    def register_shared_texture(self, *args):
        """
        register_shared_texture(self, colorId:int, depthId:int=0) -> None
        C++: void register_shared_texture(unsigned int colorId,
            unsigned int depthId=0)
        register_shared_texture(self) -> None
        C++: void register_shared_texture()
        Register/Unregister the open_gl textures designated by colorId 
        and depthId with this render window internal D3D shared textures.
        depthId is optional
        """
        ret = self._wrap_call(self._vtk_obj.RegisterSharedTexture, *args)
        return ret

    def set_d3d_device_context(self, *args):
        """
        set_d3d_device_context(self, context:Pointer) -> None
        C++: void set_d3d_device_context(void *context)"""
        ret = self._wrap_call(self._vtk_obj.SetD3DDeviceContext, *args)
        return ret

    def unlock(self):
        """
        unlock(self) -> None
        C++: void unlock()"""
        ret = self._vtk_obj.Unlock()
        return ret
        

    def unregister_shared_texture(self):
        """
        unregister_shared_texture(self) -> None
        C++: void unregister_shared_texture()"""
        ret = self._vtk_obj.UnregisterSharedTexture()
        return ret
        

    _updateable_traits_ = \
    (('framebuffer_flip_y', 'GetFramebufferFlipY'), ('borders',
    'GetBorders'), ('enable_translucent_surface',
    'GetEnableTranslucentSurface'), ('full_screen', 'GetFullScreen'),
    ('line_smoothing', 'GetLineSmoothing'), ('point_smoothing',
    'GetPointSmoothing'), ('polygon_smoothing', 'GetPolygonSmoothing'),
    ('stencil_capable', 'GetStencilCapable'), ('stereo_capable_window',
    'GetStereoCapableWindow'), ('stereo_render', 'GetStereoRender'),
    ('swap_buffers', 'GetSwapBuffers'), ('use_srgb_color_space',
    'GetUseSRGBColorSpace'), ('double_buffer', 'GetDoubleBuffer'),
    ('erase', 'GetErase'), ('off_screen_rendering',
    'GetOffScreenRendering'), ('show_window', 'GetShowWindow'),
    ('use_off_screen_buffers', 'GetUseOffScreenBuffers'), ('debug',
    'GetDebug'), ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('frame_blit_mode', 'GetFrameBlitMode'), ('stereo_type',
    'GetStereoType'), ('shared_texture_samples',
    'GetSharedTextureSamples'), ('size', 'GetSize'), ('current_cursor',
    'GetCurrentCursor'), ('position', 'GetPosition'), ('window_name',
    'GetWindowName'), ('global_maximum_number_of_multi_samples',
    'GetGlobalMaximumNumberOfMultiSamples'),
    ('render_buffer_target_depth_size', 'GetRenderBufferTargetDepthSize'),
    ('abort_render', 'GetAbortRender'), ('alpha_bit_planes',
    'GetAlphaBitPlanes'), ('anaglyph_color_mask', 'GetAnaglyphColorMask'),
    ('anaglyph_color_saturation', 'GetAnaglyphColorSaturation'),
    ('cursor_file_name', 'GetCursorFileName'), ('desired_update_rate',
    'GetDesiredUpdateRate'), ('device_index', 'GetDeviceIndex'),
    ('in_abort_check', 'GetInAbortCheck'), ('multi_samples',
    'GetMultiSamples'), ('number_of_layers', 'GetNumberOfLayers'),
    ('physical_scale', 'GetPhysicalScale'), ('physical_translation',
    'GetPhysicalTranslation'), ('physical_view_direction',
    'GetPhysicalViewDirection'), ('physical_view_up',
    'GetPhysicalViewUp'), ('dpi', 'GetDPI'), ('tile_scale',
    'GetTileScale'), ('tile_viewport', 'GetTileViewport'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['borders', 'debug', 'double_buffer', 'enable_translucent_surface',
    'erase', 'framebuffer_flip_y', 'full_screen',
    'global_warning_display', 'line_smoothing', 'off_screen_rendering',
    'point_smoothing', 'polygon_smoothing', 'show_window',
    'stencil_capable', 'stereo_capable_window', 'stereo_render',
    'swap_buffers', 'use_off_screen_buffers', 'use_srgb_color_space',
    'frame_blit_mode', 'stereo_type', 'abort_render', 'alpha_bit_planes',
    'anaglyph_color_mask', 'anaglyph_color_saturation', 'current_cursor',
    'cursor_file_name', 'desired_update_rate', 'device_index', 'dpi',
    'global_maximum_number_of_multi_samples', 'in_abort_check',
    'multi_samples', 'number_of_layers', 'object_name', 'physical_scale',
    'physical_translation', 'physical_view_direction', 'physical_view_up',
    'position', 'render_buffer_target_depth_size',
    'shared_texture_samples', 'size', 'tile_scale', 'tile_viewport',
    'window_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Win32OpenGLDXRenderWindow, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Win32OpenGLDXRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['borders', 'double_buffer', 'enable_translucent_surface',
            'erase', 'framebuffer_flip_y', 'full_screen', 'line_smoothing',
            'off_screen_rendering', 'point_smoothing', 'polygon_smoothing',
            'show_window', 'stencil_capable', 'stereo_capable_window',
            'stereo_render', 'swap_buffers', 'use_off_screen_buffers',
            'use_srgb_color_space'], ['frame_blit_mode', 'stereo_type'],
            ['abort_render', 'alpha_bit_planes', 'anaglyph_color_mask',
            'anaglyph_color_saturation', 'current_cursor', 'cursor_file_name',
            'desired_update_rate', 'device_index', 'dpi',
            'global_maximum_number_of_multi_samples', 'in_abort_check',
            'multi_samples', 'number_of_layers', 'object_name', 'physical_scale',
            'physical_translation', 'physical_view_direction', 'physical_view_up',
            'position', 'render_buffer_target_depth_size',
            'shared_texture_samples', 'size', 'tile_scale', 'tile_viewport',
            'window_name']),
            title='Edit Win32OpenGLDXRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Win32OpenGLDXRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

